import { __decorate } from 'tslib';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Directive, HostListener, NgModule } from '@angular/core';
import { fromEvent } from 'rxjs';
import { NG_VALUE_ACCESSOR } from '@angular/forms';

/* eslint-disable */
/* tslint:disable */
const proxyInputs = (Cmp, inputs) => {
    const Prototype = Cmp.prototype;
    inputs.forEach((item) => {
        Object.defineProperty(Prototype, item, {
            get() {
                return this.el[item];
            },
            set(val) {
                this.z.runOutsideAngular(() => (this.el[item] = val));
            },
            /**
             * In the event that proxyInputs is called
             * multiple times re-defining these inputs
             * will cause an error to be thrown. As a result
             * we set configurable: true to indicate these
             * properties can be changed.
             */
            configurable: true,
        });
    });
};
const proxyMethods = (Cmp, methods) => {
    const Prototype = Cmp.prototype;
    methods.forEach((methodName) => {
        Prototype[methodName] = function () {
            const args = arguments;
            return this.z.runOutsideAngular(() => this.el[methodName].apply(this.el, args));
        };
    });
};
const proxyOutputs = (instance, el, events) => {
    events.forEach((eventName) => (instance[eventName] = fromEvent(el, eventName)));
};
const defineCustomElement = (tagName, customElement) => {
    if (customElement !== undefined && typeof customElements !== 'undefined' && !customElements.get(tagName)) {
        customElements.define(tagName, customElement);
    }
};
// tslint:disable-next-line: only-arrow-functions
function ProxyCmp(opts) {
    const decorator = function (cls) {
        const { defineCustomElementFn, inputs, methods } = opts;
        if (defineCustomElementFn !== undefined) {
            defineCustomElementFn();
        }
        if (inputs) {
            proxyInputs(cls, inputs);
        }
        if (methods) {
            proxyMethods(cls, methods);
        }
        return cls;
    };
    return decorator;
}

let FileManager = class FileManager {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FileManager, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: FileManager, selector: "file-manager", ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
FileManager = __decorate([
    ProxyCmp({})
], FileManager);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FileManager, decorators: [{
            type: Component,
            args: [{
                    selector: 'file-manager',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: [],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlAccordion = class SwirlAccordion {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['expandedItemChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAccordion, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlAccordion, selector: "swirl-accordion", ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlAccordion = __decorate([
    ProxyCmp({
        methods: ['collapseItem', 'expandItem']
    })
], SwirlAccordion);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAccordion, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-accordion',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: [],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlAccordionItem = class SwirlAccordionItem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['expansionChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAccordionItem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlAccordionItem, selector: "swirl-accordion-item", inputs: { description: "description", disabled: "disabled", heading: "heading", headingLevel: "headingLevel", initiallyOpen: "initiallyOpen", itemId: "itemId" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlAccordionItem = __decorate([
    ProxyCmp({
        inputs: ['description', 'disabled', 'heading', 'headingLevel', 'initiallyOpen', 'itemId'],
        methods: ['collapse', 'expand', 'toggle']
    })
], SwirlAccordionItem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAccordionItem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-accordion-item',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['description', 'disabled', 'heading', 'headingLevel', 'initiallyOpen', 'itemId'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlActionList = class SwirlActionList {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlActionList, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlActionList, selector: "swirl-action-list", ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlActionList = __decorate([
    ProxyCmp({})
], SwirlActionList);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlActionList, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-action-list',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: [],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlActionListItem = class SwirlActionListItem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlActionListItem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlActionListItem, selector: "swirl-action-list-item", inputs: { badge: "badge", description: "description", disabled: "disabled", icon: "icon", iconBadge: "iconBadge", intent: "intent", label: "label", size: "size", suffix: "suffix", swirlAriaExpanded: "swirlAriaExpanded", swirlAriaHaspopup: "swirlAriaHaspopup" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlActionListItem = __decorate([
    ProxyCmp({
        inputs: ['badge', 'description', 'disabled', 'icon', 'iconBadge', 'intent', 'label', 'size', 'suffix', 'swirlAriaExpanded', 'swirlAriaHaspopup']
    })
], SwirlActionListItem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlActionListItem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-action-list-item',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['badge', 'description', 'disabled', 'icon', 'iconBadge', 'intent', 'label', 'size', 'suffix', 'swirlAriaExpanded', 'swirlAriaHaspopup'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlActionListSection = class SwirlActionListSection {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlActionListSection, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlActionListSection, selector: "swirl-action-list-section", inputs: { hasSeparator: "hasSeparator", label: "label", separatorSpacing: "separatorSpacing", spacing: "spacing" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlActionListSection = __decorate([
    ProxyCmp({
        inputs: ['hasSeparator', 'label', 'separatorSpacing', 'spacing']
    })
], SwirlActionListSection);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlActionListSection, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-action-list-section',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['hasSeparator', 'label', 'separatorSpacing', 'spacing'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlAppBar = class SwirlAppBar {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['backButtonClick', 'closeButtonClick', 'stepUpButtonClick', 'stepDownButtonClick']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAppBar, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlAppBar, selector: "swirl-app-bar", inputs: { backButtonLabel: "backButtonLabel", closeButtonIcon: "closeButtonIcon", closeButtonLabel: "closeButtonLabel", paddingInlineEnd: "paddingInlineEnd", paddingInlineStart: "paddingInlineStart", showBackButton: "showBackButton", showCloseButton: "showCloseButton", showStepperControls: "showStepperControls", stepDownButtonLabel: "stepDownButtonLabel", stepUpButtonLabel: "stepUpButtonLabel" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlAppBar = __decorate([
    ProxyCmp({
        inputs: ['backButtonLabel', 'closeButtonIcon', 'closeButtonLabel', 'paddingInlineEnd', 'paddingInlineStart', 'showBackButton', 'showCloseButton', 'showStepperControls', 'stepDownButtonLabel', 'stepUpButtonLabel']
    })
], SwirlAppBar);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAppBar, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-app-bar',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['backButtonLabel', 'closeButtonIcon', 'closeButtonLabel', 'paddingInlineEnd', 'paddingInlineStart', 'showBackButton', 'showCloseButton', 'showStepperControls', 'stepDownButtonLabel', 'stepUpButtonLabel'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlAppIcon = class SwirlAppIcon {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAppIcon, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlAppIcon, selector: "swirl-app-icon", inputs: { icon: "icon", src: "src" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlAppIcon = __decorate([
    ProxyCmp({
        inputs: ['icon', 'src']
    })
], SwirlAppIcon);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAppIcon, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-app-icon',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['icon', 'src'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlAppLayout = class SwirlAppLayout {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['ctaClick', 'mobileViewChange', 'navigationBackButtonClick', 'navigationExpansionStateChange', 'sidebarToggle']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAppLayout, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlAppLayout, selector: "swirl-app-layout", inputs: { appName: "appName", backToNavigationViewButtonLabel: "backToNavigationViewButtonLabel", collapsibleNavigation: "collapsibleNavigation", ctaIcon: "ctaIcon", ctaLabel: "ctaLabel", hasNavigation: "hasNavigation", hideAppBar: "hideAppBar", initialMobileView: "initialMobileView", navigationBackButtonLabel: "navigationBackButtonLabel", navigationExpansionStateStorageKey: "navigationExpansionStateStorageKey", navigationLabel: "navigationLabel", navigationOverlayLabel: "navigationOverlayLabel", navigationToggleLabel: "navigationToggleLabel", showNavigationBackButton: "showNavigationBackButton", sidebarCloseButtonLabel: "sidebarCloseButtonLabel", sidebarHeading: "sidebarHeading", transitionStyle: "transitionStyle" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlAppLayout = __decorate([
    ProxyCmp({
        inputs: ['appName', 'backToNavigationViewButtonLabel', 'collapsibleNavigation', 'ctaIcon', 'ctaLabel', 'hasNavigation', 'hideAppBar', 'initialMobileView', 'navigationBackButtonLabel', 'navigationExpansionStateStorageKey', 'navigationLabel', 'navigationOverlayLabel', 'navigationToggleLabel', 'showNavigationBackButton', 'sidebarCloseButtonLabel', 'sidebarHeading', 'transitionStyle'],
        methods: ['showSidebar', 'hideSidebar', 'toggleSidebar', 'getCollapsibleNavigationState', 'setCollapsibleNavigationState', 'changeMobileView']
    })
], SwirlAppLayout);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAppLayout, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-app-layout',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['appName', 'backToNavigationViewButtonLabel', 'collapsibleNavigation', 'ctaIcon', 'ctaLabel', 'hasNavigation', 'hideAppBar', 'initialMobileView', 'navigationBackButtonLabel', 'navigationExpansionStateStorageKey', 'navigationLabel', 'navigationOverlayLabel', 'navigationToggleLabel', 'showNavigationBackButton', 'sidebarCloseButtonLabel', 'sidebarHeading', 'transitionStyle'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlAutocomplete = class SwirlAutocomplete {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAutocomplete, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlAutocomplete, selector: "swirl-autocomplete", inputs: { autoSelect: "autoSelect", clearButtonLabel: "clearButtonLabel", clearable: "clearable", disabled: "disabled", generateSuggestions: "generateSuggestions", inline: "inline", invalid: "invalid", maxLength: "maxLength", menuLabel: "menuLabel", mode: "mode", multiSelect: "multiSelect", placeholder: "placeholder", required: "required", spellCheck: "spellCheck", swirlAriaDescribedby: "swirlAriaDescribedby", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlAutocomplete = __decorate([
    ProxyCmp({
        inputs: ['autoSelect', 'clearButtonLabel', 'clearable', 'disabled', 'generateSuggestions', 'inline', 'invalid', 'maxLength', 'menuLabel', 'mode', 'multiSelect', 'placeholder', 'required', 'spellCheck', 'swirlAriaDescribedby', 'value']
    })
], SwirlAutocomplete);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAutocomplete, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-autocomplete',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['autoSelect', 'clearButtonLabel', 'clearable', 'disabled', 'generateSuggestions', 'inline', 'invalid', 'maxLength', 'menuLabel', 'mode', 'multiSelect', 'placeholder', 'required', 'spellCheck', 'swirlAriaDescribedby', 'value'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlAvatar = class SwirlAvatar {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['imageError', 'imageLoad']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAvatar, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlAvatar, selector: "swirl-avatar", inputs: { badge: "badge", badgePosition: "badgePosition", color: "color", icon: "icon", initials: "initials", interactive: "interactive", label: "label", loading: "loading", showLabel: "showLabel", size: "size", src: "src", toolPosition: "toolPosition", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlAvatar = __decorate([
    ProxyCmp({
        inputs: ['badge', 'badgePosition', 'color', 'icon', 'initials', 'interactive', 'label', 'loading', 'showLabel', 'size', 'src', 'toolPosition', 'variant']
    })
], SwirlAvatar);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAvatar, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-avatar',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['badge', 'badgePosition', 'color', 'icon', 'initials', 'interactive', 'label', 'loading', 'showLabel', 'size', 'src', 'toolPosition', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlAvatarGroup = class SwirlAvatarGroup {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAvatarGroup, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlAvatarGroup, selector: "swirl-avatar-group", inputs: { badge: "badge" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlAvatarGroup = __decorate([
    ProxyCmp({
        inputs: ['badge']
    })
], SwirlAvatarGroup);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlAvatarGroup, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-avatar-group',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['badge'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlBadge = class SwirlBadge {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlBadge, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlBadge, selector: "swirl-badge", inputs: { icon: "icon", intent: "intent", label: "label", size: "size", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlBadge = __decorate([
    ProxyCmp({
        inputs: ['icon', 'intent', 'label', 'size', 'variant']
    })
], SwirlBadge);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlBadge, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-badge',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['icon', 'intent', 'label', 'size', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlBanner = class SwirlBanner {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['action', 'dismiss']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlBanner, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlBanner, selector: "swirl-banner", inputs: { actionLabel: "actionLabel", content: "content", dismissLabel: "dismissLabel", dismissable: "dismissable", icon: "icon", importance: "importance", intent: "intent", showIcon: "showIcon", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlBanner = __decorate([
    ProxyCmp({
        inputs: ['actionLabel', 'content', 'dismissLabel', 'dismissable', 'icon', 'importance', 'intent', 'showIcon', 'size']
    })
], SwirlBanner);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlBanner, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-banner',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['actionLabel', 'content', 'dismissLabel', 'dismissable', 'icon', 'importance', 'intent', 'showIcon', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlBox = class SwirlBox {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['componentLoad']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlBox, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlBox, selector: "swirl-box", inputs: { basis: "basis", borderColor: "borderColor", bordered: "bordered", borderedBlockEnd: "borderedBlockEnd", borderedBlockEndWhenScrolled: "borderedBlockEndWhenScrolled", borderedBlockStart: "borderedBlockStart", borderedBlockStartWhenScrolled: "borderedBlockStartWhenScrolled", borderedInlineEnd: "borderedInlineEnd", borderedInlineStart: "borderedInlineStart", bottom: "bottom", centerBlock: "centerBlock", centerInline: "centerInline", cover: "cover", grow: "grow", height: "height", left: "left", maxHeight: "maxHeight", maxWidth: "maxWidth", minHeight: "minHeight", minWidth: "minWidth", overflow: "overflow", padding: "padding", paddingBlockEnd: "paddingBlockEnd", paddingBlockStart: "paddingBlockStart", paddingInlineEnd: "paddingInlineEnd", paddingInlineStart: "paddingInlineStart", position: "position", right: "right", shrink: "shrink", top: "top", width: "width", zIndex: "zIndex" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlBox = __decorate([
    ProxyCmp({
        inputs: ['basis', 'borderColor', 'bordered', 'borderedBlockEnd', 'borderedBlockEndWhenScrolled', 'borderedBlockStart', 'borderedBlockStartWhenScrolled', 'borderedInlineEnd', 'borderedInlineStart', 'bottom', 'centerBlock', 'centerInline', 'cover', 'grow', 'height', 'left', 'maxHeight', 'maxWidth', 'minHeight', 'minWidth', 'overflow', 'padding', 'paddingBlockEnd', 'paddingBlockStart', 'paddingInlineEnd', 'paddingInlineStart', 'position', 'right', 'shrink', 'top', 'width', 'zIndex']
    })
], SwirlBox);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlBox, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-box',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['basis', 'borderColor', 'bordered', 'borderedBlockEnd', 'borderedBlockEndWhenScrolled', 'borderedBlockStart', 'borderedBlockStartWhenScrolled', 'borderedInlineEnd', 'borderedInlineStart', 'bottom', 'centerBlock', 'centerInline', 'cover', 'grow', 'height', 'left', 'maxHeight', 'maxWidth', 'minHeight', 'minWidth', 'overflow', 'padding', 'paddingBlockEnd', 'paddingBlockStart', 'paddingInlineEnd', 'paddingInlineStart', 'position', 'right', 'shrink', 'top', 'width', 'zIndex'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlButton = class SwirlButton {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlButton, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlButton, selector: "swirl-button", inputs: { disabled: "disabled", download: "download", elevated: "elevated", form: "form", hideLabel: "hideLabel", href: "href", icon: "icon", iconPosition: "iconPosition", inheritFontSize: "inheritFontSize", intent: "intent", label: "label", name: "name", pill: "pill", pressed: "pressed", size: "size", swirlAriaControls: "swirlAriaControls", swirlAriaCurrent: "swirlAriaCurrent", swirlAriaDescribedby: "swirlAriaDescribedby", swirlAriaExpanded: "swirlAriaExpanded", swirlAriaHaspopup: "swirlAriaHaspopup", swirlAriaLabel: "swirlAriaLabel", target: "target", textAlign: "textAlign", type: "type", value: "value", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlButton = __decorate([
    ProxyCmp({
        inputs: ['disabled', 'download', 'elevated', 'form', 'hideLabel', 'href', 'icon', 'iconPosition', 'inheritFontSize', 'intent', 'label', 'name', 'pill', 'pressed', 'size', 'swirlAriaControls', 'swirlAriaCurrent', 'swirlAriaDescribedby', 'swirlAriaExpanded', 'swirlAriaHaspopup', 'swirlAriaLabel', 'target', 'textAlign', 'type', 'value', 'variant']
    })
], SwirlButton);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlButton, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-button',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['disabled', 'download', 'elevated', 'form', 'hideLabel', 'href', 'icon', 'iconPosition', 'inheritFontSize', 'intent', 'label', 'name', 'pill', 'pressed', 'size', 'swirlAriaControls', 'swirlAriaCurrent', 'swirlAriaDescribedby', 'swirlAriaExpanded', 'swirlAriaHaspopup', 'swirlAriaLabel', 'target', 'textAlign', 'type', 'value', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlButtonGroup = class SwirlButtonGroup {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlButtonGroup, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlButtonGroup, selector: "swirl-button-group", inputs: { orientation: "orientation", segmented: "segmented", spacing: "spacing", stretch: "stretch", wrap: "wrap" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlButtonGroup = __decorate([
    ProxyCmp({
        inputs: ['orientation', 'segmented', 'spacing', 'stretch', 'wrap']
    })
], SwirlButtonGroup);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlButtonGroup, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-button-group',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['orientation', 'segmented', 'spacing', 'stretch', 'wrap'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlCard = class SwirlCard {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['componentLoad']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlCard, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlCard, selector: "swirl-card", inputs: { as: "as", borderRadius: "borderRadius", customBackgroundColor: "customBackgroundColor", elevated: "elevated", elevationLevel: "elevationLevel", height: "height", highlighted: "highlighted", href: "href", imageAspectRatio: "imageAspectRatio", intent: "intent", interactive: "interactive", isBorderless: "isBorderless", justifyContent: "justifyContent", linkTarget: "linkTarget", minHeight: "minHeight", overflow: "overflow", padding: "padding", paddingBlockEnd: "paddingBlockEnd", paddingBlockStart: "paddingBlockStart", paddingInlineEnd: "paddingInlineEnd", paddingInlineStart: "paddingInlineStart", swirlAriaLabel: "swirlAriaLabel", swirlAriaLabelledby: "swirlAriaLabelledby" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlCard = __decorate([
    ProxyCmp({
        inputs: ['as', 'borderRadius', 'customBackgroundColor', 'elevated', 'elevationLevel', 'height', 'highlighted', 'href', 'imageAspectRatio', 'intent', 'interactive', 'isBorderless', 'justifyContent', 'linkTarget', 'minHeight', 'overflow', 'padding', 'paddingBlockEnd', 'paddingBlockStart', 'paddingInlineEnd', 'paddingInlineStart', 'swirlAriaLabel', 'swirlAriaLabelledby'],
        methods: ['flash']
    })
], SwirlCard);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlCard, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-card',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['as', 'borderRadius', 'customBackgroundColor', 'elevated', 'elevationLevel', 'height', 'highlighted', 'href', 'imageAspectRatio', 'intent', 'interactive', 'isBorderless', 'justifyContent', 'linkTarget', 'minHeight', 'overflow', 'padding', 'paddingBlockEnd', 'paddingBlockStart', 'paddingInlineEnd', 'paddingInlineStart', 'swirlAriaLabel', 'swirlAriaLabelledby'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlCarousel = class SwirlCarousel {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['activeSlidesChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlCarousel, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlCarousel, selector: "swirl-carousel", inputs: { fade: "fade", fadeColor: "fadeColor", label: "label", loopAround: "loopAround", nextSlideButtonLabel: "nextSlideButtonLabel", padding: "padding", paddingBlockEnd: "paddingBlockEnd", paddingBlockStart: "paddingBlockStart", paddingInlineEnd: "paddingInlineEnd", paddingInlineStart: "paddingInlineStart", previousSlideButtonLabel: "previousSlideButtonLabel", spacing: "spacing" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlCarousel = __decorate([
    ProxyCmp({
        inputs: ['fade', 'fadeColor', 'label', 'loopAround', 'nextSlideButtonLabel', 'padding', 'paddingBlockEnd', 'paddingBlockStart', 'paddingInlineEnd', 'paddingInlineStart', 'previousSlideButtonLabel', 'spacing'],
        methods: ['scrollToSlide']
    })
], SwirlCarousel);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlCarousel, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-carousel',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['fade', 'fadeColor', 'label', 'loopAround', 'nextSlideButtonLabel', 'padding', 'paddingBlockEnd', 'paddingBlockStart', 'paddingInlineEnd', 'paddingInlineStart', 'previousSlideButtonLabel', 'spacing'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlCarouselSlide = class SwirlCarouselSlide {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlCarouselSlide, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlCarouselSlide, selector: "swirl-carousel-slide", inputs: { aspectRatio: "aspectRatio", label: "label", minHeight: "minHeight", width: "width" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlCarouselSlide = __decorate([
    ProxyCmp({
        inputs: ['aspectRatio', 'label', 'minHeight', 'width']
    })
], SwirlCarouselSlide);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlCarouselSlide, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-carousel-slide',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['aspectRatio', 'label', 'minHeight', 'width'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlCheckbox = class SwirlCheckbox {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlCheckbox, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlCheckbox, selector: "swirl-checkbox", inputs: { checked: "checked", description: "description", disabled: "disabled", inputId: "inputId", inputName: "inputName", invalid: "invalid", label: "label", labelWeight: "labelWeight", swirlAriaDescribedby: "swirlAriaDescribedby", swirlAriaLabel: "swirlAriaLabel", value: "value", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlCheckbox = __decorate([
    ProxyCmp({
        inputs: ['checked', 'description', 'disabled', 'inputId', 'inputName', 'invalid', 'label', 'labelWeight', 'swirlAriaDescribedby', 'swirlAriaLabel', 'value', 'variant']
    })
], SwirlCheckbox);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlCheckbox, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-checkbox',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['checked', 'description', 'disabled', 'inputId', 'inputName', 'invalid', 'label', 'labelWeight', 'swirlAriaDescribedby', 'swirlAriaLabel', 'value', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlChip = class SwirlChip {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['chipClick', 'remove']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlChip, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlChip, selector: "swirl-chip", inputs: { borderRadius: "borderRadius", icon: "icon", iconColor: "iconColor", intent: "intent", interactive: "interactive", label: "label", pressed: "pressed", progress: "progress", progressBarLabel: "progressBarLabel", removable: "removable", removeButtonLabel: "removeButtonLabel", size: "size", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlChip = __decorate([
    ProxyCmp({
        inputs: ['borderRadius', 'icon', 'iconColor', 'intent', 'interactive', 'label', 'pressed', 'progress', 'progressBarLabel', 'removable', 'removeButtonLabel', 'size', 'variant']
    })
], SwirlChip);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlChip, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-chip',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['borderRadius', 'icon', 'iconColor', 'intent', 'interactive', 'label', 'pressed', 'progress', 'progressBarLabel', 'removable', 'removeButtonLabel', 'size', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlColorInput = class SwirlColorInput {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['inputBlur', 'inputFocus', 'valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlColorInput, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlColorInput, selector: "swirl-color-input", inputs: { autoFocus: "autoFocus", autoSelect: "autoSelect", disabled: "disabled", inline: "inline", invalid: "invalid", pickerButtonLabel: "pickerButtonLabel", pickerLabel: "pickerLabel", placeholder: "placeholder", required: "required", swirlAriaDescribedby: "swirlAriaDescribedby", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlColorInput = __decorate([
    ProxyCmp({
        inputs: ['autoFocus', 'autoSelect', 'disabled', 'inline', 'invalid', 'pickerButtonLabel', 'pickerLabel', 'placeholder', 'required', 'swirlAriaDescribedby', 'value']
    })
], SwirlColorInput);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlColorInput, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-color-input',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['autoFocus', 'autoSelect', 'disabled', 'inline', 'invalid', 'pickerButtonLabel', 'pickerLabel', 'placeholder', 'required', 'swirlAriaDescribedby', 'value'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlColumns = class SwirlColumns {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlColumns, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlColumns, selector: "swirl-columns", inputs: { columns: "columns", spacing: "spacing" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlColumns = __decorate([
    ProxyCmp({
        inputs: ['columns', 'spacing']
    })
], SwirlColumns);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlColumns, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-columns',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['columns', 'spacing'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlConsoleLayout = class SwirlConsoleLayout {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['backButtonClick', 'helpButtonClick']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlConsoleLayout, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlConsoleLayout, selector: "swirl-console-layout", inputs: { appName: "appName", backButonLabel: "backButonLabel", heading: "heading", helpButonLabel: "helpButonLabel", hideNavigationButtonLabel: "hideNavigationButtonLabel", logoText: "logoText", maxContentWidth: "maxContentWidth", navigationLabel: "navigationLabel", showBackButton: "showBackButton", showHelpButton: "showHelpButton", showNavigationButtonLabel: "showNavigationButtonLabel", subheading: "subheading" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlConsoleLayout = __decorate([
    ProxyCmp({
        inputs: ['appName', 'backButonLabel', 'heading', 'helpButonLabel', 'hideNavigationButtonLabel', 'logoText', 'maxContentWidth', 'navigationLabel', 'showBackButton', 'showHelpButton', 'showNavigationButtonLabel', 'subheading'],
        methods: ['toggleSidebar', 'showSidebar', 'hideSidebar']
    })
], SwirlConsoleLayout);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlConsoleLayout, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-console-layout',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['appName', 'backButonLabel', 'heading', 'helpButonLabel', 'hideNavigationButtonLabel', 'logoText', 'maxContentWidth', 'navigationLabel', 'showBackButton', 'showHelpButton', 'showNavigationButtonLabel', 'subheading'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlDateInput = class SwirlDateInput {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['invalidInput', 'valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlDateInput, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlDateInput, selector: "swirl-date-input", inputs: { autoFocus: "autoFocus", autoSelect: "autoSelect", datePickerDisableDate: "datePickerDisableDate", datePickerLabel: "datePickerLabel", datePickerTriggerLabel: "datePickerTriggerLabel", disabled: "disabled", firstDayOfWeek: "firstDayOfWeek", format: "format", inline: "inline", invalid: "invalid", labels: "labels", locale: "locale", placeholder: "placeholder", preferredInputMode: "preferredInputMode", required: "required", swirlAriaDescribedby: "swirlAriaDescribedby", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlDateInput = __decorate([
    ProxyCmp({
        inputs: ['autoFocus', 'autoSelect', 'datePickerDisableDate', 'datePickerLabel', 'datePickerTriggerLabel', 'disabled', 'firstDayOfWeek', 'format', 'inline', 'invalid', 'labels', 'locale', 'placeholder', 'preferredInputMode', 'required', 'swirlAriaDescribedby', 'value']
    })
], SwirlDateInput);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlDateInput, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-date-input',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['autoFocus', 'autoSelect', 'datePickerDisableDate', 'datePickerLabel', 'datePickerTriggerLabel', 'disabled', 'firstDayOfWeek', 'format', 'inline', 'invalid', 'labels', 'locale', 'placeholder', 'preferredInputMode', 'required', 'swirlAriaDescribedby', 'value'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlDatePicker = class SwirlDatePicker {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlDatePicker, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlDatePicker, selector: "swirl-date-picker", inputs: { disableDate: "disableDate", firstDayOfWeek: "firstDayOfWeek", labels: "labels", locale: "locale", range: "range", startDate: "startDate", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlDatePicker = __decorate([
    ProxyCmp({
        inputs: ['disableDate', 'firstDayOfWeek', 'labels', 'locale', 'range', 'startDate', 'value']
    })
], SwirlDatePicker);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlDatePicker, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-date-picker',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['disableDate', 'firstDayOfWeek', 'labels', 'locale', 'range', 'startDate', 'value'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlDescriptionList = class SwirlDescriptionList {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlDescriptionList, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlDescriptionList, selector: "swirl-description-list", ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlDescriptionList = __decorate([
    ProxyCmp({})
], SwirlDescriptionList);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlDescriptionList, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-description-list',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: [],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlDescriptionListItem = class SwirlDescriptionListItem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlDescriptionListItem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlDescriptionListItem, selector: "swirl-description-list-item", inputs: { bordered: "bordered", maxWidth: "maxWidth", term: "term", tooltip: "tooltip" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlDescriptionListItem = __decorate([
    ProxyCmp({
        inputs: ['bordered', 'maxWidth', 'term', 'tooltip']
    })
], SwirlDescriptionListItem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlDescriptionListItem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-description-list-item',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['bordered', 'maxWidth', 'term', 'tooltip'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlDialog = class SwirlDialog {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['dialogClose', 'dialogOpen', 'primaryAction', 'secondaryAction']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlDialog, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlDialog, selector: "swirl-dialog", inputs: { hideLabel: "hideLabel", intent: "intent", label: "label", primaryActionLabel: "primaryActionLabel", secondaryActionLabel: "secondaryActionLabel" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlDialog = __decorate([
    ProxyCmp({
        inputs: ['hideLabel', 'intent', 'label', 'primaryActionLabel', 'secondaryActionLabel'],
        methods: ['open', 'close']
    })
], SwirlDialog);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlDialog, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-dialog',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['hideLabel', 'intent', 'label', 'primaryActionLabel', 'secondaryActionLabel'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlEmoji = class SwirlEmoji {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmoji, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlEmoji, selector: "swirl-emoji", inputs: { label: "label", name: "name", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlEmoji = __decorate([
    ProxyCmp({
        inputs: ['label', 'name', 'size']
    })
], SwirlEmoji);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmoji, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-emoji',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['label', 'name', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlEmojiClap = class SwirlEmojiClap {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmojiClap, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlEmojiClap, selector: "swirl-emoji-clap", inputs: { label: "label", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlEmojiClap = __decorate([
    ProxyCmp({
        inputs: ['label', 'size']
    })
], SwirlEmojiClap);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmojiClap, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-emoji-clap',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['label', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlEmojiHappy = class SwirlEmojiHappy {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmojiHappy, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlEmojiHappy, selector: "swirl-emoji-happy", inputs: { label: "label", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlEmojiHappy = __decorate([
    ProxyCmp({
        inputs: ['label', 'size']
    })
], SwirlEmojiHappy);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmojiHappy, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-emoji-happy',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['label', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlEmojiIdea = class SwirlEmojiIdea {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmojiIdea, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlEmojiIdea, selector: "swirl-emoji-idea", inputs: { label: "label", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlEmojiIdea = __decorate([
    ProxyCmp({
        inputs: ['label', 'size']
    })
], SwirlEmojiIdea);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmojiIdea, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-emoji-idea',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['label', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlEmojiLove = class SwirlEmojiLove {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmojiLove, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlEmojiLove, selector: "swirl-emoji-love", inputs: { label: "label", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlEmojiLove = __decorate([
    ProxyCmp({
        inputs: ['label', 'size']
    })
], SwirlEmojiLove);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmojiLove, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-emoji-love',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['label', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlEmojiSad = class SwirlEmojiSad {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmojiSad, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlEmojiSad, selector: "swirl-emoji-sad", inputs: { label: "label", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlEmojiSad = __decorate([
    ProxyCmp({
        inputs: ['label', 'size']
    })
], SwirlEmojiSad);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmojiSad, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-emoji-sad',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['label', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlEmojiThumbsUp = class SwirlEmojiThumbsUp {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmojiThumbsUp, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlEmojiThumbsUp, selector: "swirl-emoji-thumbs-up", inputs: { label: "label", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlEmojiThumbsUp = __decorate([
    ProxyCmp({
        inputs: ['label', 'size']
    })
], SwirlEmojiThumbsUp);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmojiThumbsUp, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-emoji-thumbs-up',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['label', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlEmptyState = class SwirlEmptyState {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmptyState, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlEmptyState, selector: "swirl-empty-state", inputs: { heading: "heading", headingLevel: "headingLevel", illustration: "illustration" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlEmptyState = __decorate([
    ProxyCmp({
        inputs: ['heading', 'headingLevel', 'illustration']
    })
], SwirlEmptyState);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlEmptyState, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-empty-state',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['heading', 'headingLevel', 'illustration'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlFileChip = class SwirlFileChip {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['preview', 'download']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileChip, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlFileChip, selector: "swirl-file-chip", inputs: { description: "description", downloadButtonLabel: "downloadButtonLabel", loading: "loading", loadingLabel: "loadingLabel", name: "name", previewButtonLabel: "previewButtonLabel", showDownloadButton: "showDownloadButton", showPreviewButton: "showPreviewButton", skipNativeDownload: "skipNativeDownload", type: "type", url: "url" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlFileChip = __decorate([
    ProxyCmp({
        inputs: ['description', 'downloadButtonLabel', 'loading', 'loadingLabel', 'name', 'previewButtonLabel', 'showDownloadButton', 'showPreviewButton', 'skipNativeDownload', 'type', 'url']
    })
], SwirlFileChip);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileChip, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-file-chip',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['description', 'downloadButtonLabel', 'loading', 'loadingLabel', 'name', 'previewButtonLabel', 'showDownloadButton', 'showPreviewButton', 'skipNativeDownload', 'type', 'url'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlFileUploader = class SwirlFileUploader {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileUploader, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlFileUploader, selector: "swirl-file-uploader", inputs: { accept: "accept", ctaLabel: "ctaLabel", description: "description", descriptionAllowHtml: "descriptionAllowHtml", disabled: "disabled", dragDropLabel: "dragDropLabel", hideLabel: "hideLabel", inputId: "inputId", inputName: "inputName", label: "label", multiple: "multiple", showDropzone: "showDropzone", uploadButtonIcon: "uploadButtonIcon", uploadButtonLabel: "uploadButtonLabel", uploadButtonVariant: "uploadButtonVariant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlFileUploader = __decorate([
    ProxyCmp({
        inputs: ['accept', 'ctaLabel', 'description', 'descriptionAllowHtml', 'disabled', 'dragDropLabel', 'hideLabel', 'inputId', 'inputName', 'label', 'multiple', 'showDropzone', 'uploadButtonIcon', 'uploadButtonLabel', 'uploadButtonVariant'],
        methods: ['reset']
    })
], SwirlFileUploader);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileUploader, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-file-uploader',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['accept', 'ctaLabel', 'description', 'descriptionAllowHtml', 'disabled', 'dragDropLabel', 'hideLabel', 'inputId', 'inputName', 'label', 'multiple', 'showDropzone', 'uploadButtonIcon', 'uploadButtonLabel', 'uploadButtonVariant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlFileViewer = class SwirlFileViewer {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['activate', 'visiblePagesChange', 'downloadStart']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewer, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlFileViewer, selector: "swirl-file-viewer", inputs: { active: "active", autoplay: "autoplay", description: "description", disableDownload: "disableDownload", errorMessage: "errorMessage", file: "file", fileName: "fileName", pdfWorkerSrc: "pdfWorkerSrc", skipNativeDownload: "skipNativeDownload", thumbnailUrl: "thumbnailUrl", type: "type", typeUnsupportedMessage: "typeUnsupportedMessage", viewMode: "viewMode", zoom: "zoom" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlFileViewer = __decorate([
    ProxyCmp({
        inputs: ['active', 'autoplay', 'description', 'disableDownload', 'errorMessage', 'file', 'fileName', 'pdfWorkerSrc', 'skipNativeDownload', 'thumbnailUrl', 'type', 'typeUnsupportedMessage', 'viewMode', 'zoom'],
        methods: ['download', 'print']
    })
], SwirlFileViewer);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewer, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-file-viewer',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['active', 'autoplay', 'description', 'disableDownload', 'errorMessage', 'file', 'fileName', 'pdfWorkerSrc', 'skipNativeDownload', 'thumbnailUrl', 'type', 'typeUnsupportedMessage', 'viewMode', 'zoom'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlFileViewerAudio = class SwirlFileViewerAudio {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['activate']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerAudio, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlFileViewerAudio, selector: "swirl-file-viewer-audio", inputs: { autoplay: "autoplay", file: "file" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlFileViewerAudio = __decorate([
    ProxyCmp({
        inputs: ['autoplay', 'file']
    })
], SwirlFileViewerAudio);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerAudio, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-file-viewer-audio',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['autoplay', 'file'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlFileViewerCsv = class SwirlFileViewerCsv {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['activate']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerCsv, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlFileViewerCsv, selector: "swirl-file-viewer-csv", inputs: { errorMessage: "errorMessage", file: "file" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlFileViewerCsv = __decorate([
    ProxyCmp({
        inputs: ['errorMessage', 'file']
    })
], SwirlFileViewerCsv);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerCsv, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-file-viewer-csv',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['errorMessage', 'file'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlFileViewerFallback = class SwirlFileViewerFallback {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['activate', 'download']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerFallback, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlFileViewerFallback, selector: "swirl-file-viewer-fallback", inputs: { disableDownload: "disableDownload", downloadButtonLabel: "downloadButtonLabel", file: "file", fileName: "fileName" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlFileViewerFallback = __decorate([
    ProxyCmp({
        inputs: ['disableDownload', 'downloadButtonLabel', 'file', 'fileName']
    })
], SwirlFileViewerFallback);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerFallback, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-file-viewer-fallback',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['disableDownload', 'downloadButtonLabel', 'file', 'fileName'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlFileViewerImage = class SwirlFileViewerImage {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['activate']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerImage, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlFileViewerImage, selector: "swirl-file-viewer-image", inputs: { description: "description", errorMessage: "errorMessage", file: "file", maxZoom: "maxZoom" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlFileViewerImage = __decorate([
    ProxyCmp({
        inputs: ['description', 'errorMessage', 'file', 'maxZoom'],
        methods: ['getZoom', 'resetZoom']
    })
], SwirlFileViewerImage);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerImage, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-file-viewer-image',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['description', 'errorMessage', 'file', 'maxZoom'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlFileViewerPdf = class SwirlFileViewerPdf {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['activate', 'visiblePagesChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerPdf, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlFileViewerPdf, selector: "swirl-file-viewer-pdf", inputs: { errorMessage: "errorMessage", file: "file", singlePageMode: "singlePageMode", viewMode: "viewMode", workerSrc: "workerSrc", zoom: "zoom" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlFileViewerPdf = __decorate([
    ProxyCmp({
        inputs: ['errorMessage', 'file', 'singlePageMode', 'viewMode', 'workerSrc', 'zoom'],
        methods: ['getThumbnails', 'print', 'nextPage', 'previousPage', 'setPage']
    })
], SwirlFileViewerPdf);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerPdf, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-file-viewer-pdf',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['errorMessage', 'file', 'singlePageMode', 'viewMode', 'workerSrc', 'zoom'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlFileViewerText = class SwirlFileViewerText {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['activate']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerText, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlFileViewerText, selector: "swirl-file-viewer-text", inputs: { errorMessage: "errorMessage", file: "file" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlFileViewerText = __decorate([
    ProxyCmp({
        inputs: ['errorMessage', 'file']
    })
], SwirlFileViewerText);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerText, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-file-viewer-text',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['errorMessage', 'file'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlFileViewerVideo = class SwirlFileViewerVideo {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['activate']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerVideo, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlFileViewerVideo, selector: "swirl-file-viewer-video", inputs: { autoplay: "autoplay", disableDownload: "disableDownload", file: "file" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlFileViewerVideo = __decorate([
    ProxyCmp({
        inputs: ['autoplay', 'disableDownload', 'file']
    })
], SwirlFileViewerVideo);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFileViewerVideo, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-file-viewer-video',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['autoplay', 'disableDownload', 'file'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlFormControl = class SwirlFormControl {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFormControl, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlFormControl, selector: "swirl-form-control", inputs: { description: "description", disabled: "disabled", errorMessage: "errorMessage", fontSize: "fontSize", hideLabel: "hideLabel", icon: "icon", inline: "inline", invalid: "invalid", label: "label", labelPosition: "labelPosition", secondaryLabel: "secondaryLabel", tooltip: "tooltip" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlFormControl = __decorate([
    ProxyCmp({
        inputs: ['description', 'disabled', 'errorMessage', 'fontSize', 'hideLabel', 'icon', 'inline', 'invalid', 'label', 'labelPosition', 'secondaryLabel', 'tooltip']
    })
], SwirlFormControl);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFormControl, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-form-control',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['description', 'disabled', 'errorMessage', 'fontSize', 'hideLabel', 'icon', 'inline', 'invalid', 'label', 'labelPosition', 'secondaryLabel', 'tooltip'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlFormGroup = class SwirlFormGroup {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFormGroup, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlFormGroup, selector: "swirl-form-group", inputs: { orientation: "orientation" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlFormGroup = __decorate([
    ProxyCmp({
        inputs: ['orientation']
    })
], SwirlFormGroup);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlFormGroup, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-form-group',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['orientation'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlHeading = class SwirlHeading {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlHeading, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlHeading, selector: "swirl-heading", inputs: { align: "align", as: "as", balance: "balance", headingId: "headingId", level: "level", lines: "lines", text: "text", truncate: "truncate" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlHeading = __decorate([
    ProxyCmp({
        inputs: ['align', 'as', 'balance', 'headingId', 'level', 'lines', 'text', 'truncate']
    })
], SwirlHeading);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlHeading, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-heading',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['align', 'as', 'balance', 'headingId', 'level', 'lines', 'text', 'truncate'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIcon = class SwirlIcon {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIcon, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIcon, selector: "swirl-icon", inputs: { color: "color", glyph: "glyph", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIcon = __decorate([
    ProxyCmp({
        inputs: ['color', 'glyph', 'size']
    })
], SwirlIcon);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIcon, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'glyph', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconAdd = class SwirlIconAdd {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAdd, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconAdd, selector: "swirl-icon-add", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconAdd = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconAdd);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAdd, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-add',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconAddModerator = class SwirlIconAddModerator {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAddModerator, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconAddModerator, selector: "swirl-icon-add-moderator", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconAddModerator = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconAddModerator);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAddModerator, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-add-moderator',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconAddPhoto = class SwirlIconAddPhoto {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAddPhoto, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconAddPhoto, selector: "swirl-icon-add-photo", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconAddPhoto = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconAddPhoto);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAddPhoto, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-add-photo',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconAddReaction = class SwirlIconAddReaction {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAddReaction, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconAddReaction, selector: "swirl-icon-add-reaction", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconAddReaction = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconAddReaction);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAddReaction, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-add-reaction',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconAdminPanelSettings = class SwirlIconAdminPanelSettings {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAdminPanelSettings, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconAdminPanelSettings, selector: "swirl-icon-admin-panel-settings", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconAdminPanelSettings = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconAdminPanelSettings);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAdminPanelSettings, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-admin-panel-settings',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconAi = class SwirlIconAi {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAi, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconAi, selector: "swirl-icon-ai", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconAi = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconAi);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAi, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-ai',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconAiFilled = class SwirlIconAiFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAiFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconAiFilled, selector: "swirl-icon-ai-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconAiFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconAiFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAiFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-ai-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconApps = class SwirlIconApps {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconApps, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconApps, selector: "swirl-icon-apps", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconApps = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconApps);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconApps, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-apps',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconArrowBack = class SwirlIconArrowBack {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowBack, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconArrowBack, selector: "swirl-icon-arrow-back", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconArrowBack = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconArrowBack);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowBack, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-arrow-back',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconArrowDownward = class SwirlIconArrowDownward {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowDownward, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconArrowDownward, selector: "swirl-icon-arrow-downward", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconArrowDownward = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconArrowDownward);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowDownward, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-arrow-downward',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconArrowForward = class SwirlIconArrowForward {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowForward, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconArrowForward, selector: "swirl-icon-arrow-forward", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconArrowForward = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconArrowForward);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowForward, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-arrow-forward',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconArrowLeft = class SwirlIconArrowLeft {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowLeft, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconArrowLeft, selector: "swirl-icon-arrow-left", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconArrowLeft = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconArrowLeft);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowLeft, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-arrow-left',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconArrowRight = class SwirlIconArrowRight {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowRight, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconArrowRight, selector: "swirl-icon-arrow-right", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconArrowRight = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconArrowRight);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowRight, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-arrow-right',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconArrowRightSmall = class SwirlIconArrowRightSmall {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowRightSmall, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconArrowRightSmall, selector: "swirl-icon-arrow-right-small", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconArrowRightSmall = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconArrowRightSmall);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowRightSmall, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-arrow-right-small',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconArrowUpward = class SwirlIconArrowUpward {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowUpward, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconArrowUpward, selector: "swirl-icon-arrow-upward", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconArrowUpward = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconArrowUpward);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconArrowUpward, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-arrow-upward',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconAspectRatio = class SwirlIconAspectRatio {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAspectRatio, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconAspectRatio, selector: "swirl-icon-aspect-ratio", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconAspectRatio = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconAspectRatio);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAspectRatio, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-aspect-ratio',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconAttachment = class SwirlIconAttachment {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAttachment, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconAttachment, selector: "swirl-icon-attachment", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconAttachment = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconAttachment);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAttachment, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-attachment',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconAudioFile = class SwirlIconAudioFile {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAudioFile, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconAudioFile, selector: "swirl-icon-audio-file", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconAudioFile = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconAudioFile);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconAudioFile, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-audio-file',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconBarChart = class SwirlIconBarChart {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconBarChart, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconBarChart, selector: "swirl-icon-bar-chart", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconBarChart = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconBarChart);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconBarChart, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-bar-chart',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconBeachAccess = class SwirlIconBeachAccess {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconBeachAccess, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconBeachAccess, selector: "swirl-icon-beach-access", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconBeachAccess = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconBeachAccess);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconBeachAccess, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-beach-access',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconBeachAccessFilled = class SwirlIconBeachAccessFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconBeachAccessFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconBeachAccessFilled, selector: "swirl-icon-beach-access-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconBeachAccessFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconBeachAccessFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconBeachAccessFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-beach-access-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconBlock = class SwirlIconBlock {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconBlock, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconBlock, selector: "swirl-icon-block", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconBlock = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconBlock);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconBlock, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-block',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconBookmark = class SwirlIconBookmark {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconBookmark, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconBookmark, selector: "swirl-icon-bookmark", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconBookmark = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconBookmark);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconBookmark, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-bookmark',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconBookmarkFilled = class SwirlIconBookmarkFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconBookmarkFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconBookmarkFilled, selector: "swirl-icon-bookmark-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconBookmarkFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconBookmarkFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconBookmarkFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-bookmark-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCalendarAddOnFilled = class SwirlIconCalendarAddOnFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCalendarAddOnFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCalendarAddOnFilled, selector: "swirl-icon-calendar-add-on-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCalendarAddOnFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCalendarAddOnFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCalendarAddOnFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-calendar-add-on-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCalendarRespond = class SwirlIconCalendarRespond {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCalendarRespond, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCalendarRespond, selector: "swirl-icon-calendar-respond", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCalendarRespond = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCalendarRespond);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCalendarRespond, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-calendar-respond',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCalendarToday = class SwirlIconCalendarToday {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCalendarToday, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCalendarToday, selector: "swirl-icon-calendar-today", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCalendarToday = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCalendarToday);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCalendarToday, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-calendar-today',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCall = class SwirlIconCall {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCall, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCall, selector: "swirl-icon-call", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCall = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCall);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCall, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-call',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCallEnd = class SwirlIconCallEnd {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCallEnd, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCallEnd, selector: "swirl-icon-call-end", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCallEnd = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCallEnd);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCallEnd, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-call-end',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCancel = class SwirlIconCancel {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCancel, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCancel, selector: "swirl-icon-cancel", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCancel = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCancel);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCancel, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-cancel',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCancelFilled = class SwirlIconCancelFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCancelFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCancelFilled, selector: "swirl-icon-cancel-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCancelFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCancelFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCancelFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-cancel-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconChatBubble = class SwirlIconChatBubble {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconChatBubble, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconChatBubble, selector: "swirl-icon-chat-bubble", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconChatBubble = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconChatBubble);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconChatBubble, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-chat-bubble',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconChats = class SwirlIconChats {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconChats, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconChats, selector: "swirl-icon-chats", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconChats = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconChats);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconChats, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-chats',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconChatsFilled = class SwirlIconChatsFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconChatsFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconChatsFilled, selector: "swirl-icon-chats-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconChatsFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconChatsFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconChatsFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-chats-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCheck = class SwirlIconCheck {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCheck, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCheck, selector: "swirl-icon-check", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCheck = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCheck);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCheck, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-check',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCheckCircle = class SwirlIconCheckCircle {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCheckCircle, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCheckCircle, selector: "swirl-icon-check-circle", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCheckCircle = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCheckCircle);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCheckCircle, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-check-circle',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCheckCircleFilled = class SwirlIconCheckCircleFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCheckCircleFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCheckCircleFilled, selector: "swirl-icon-check-circle-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCheckCircleFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCheckCircleFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCheckCircleFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-check-circle-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCheckSmall = class SwirlIconCheckSmall {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCheckSmall, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCheckSmall, selector: "swirl-icon-check-small", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCheckSmall = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCheckSmall);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCheckSmall, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-check-small',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCheckStrong = class SwirlIconCheckStrong {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCheckStrong, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCheckStrong, selector: "swirl-icon-check-strong", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCheckStrong = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCheckStrong);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCheckStrong, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-check-strong',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconChevronLeft = class SwirlIconChevronLeft {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconChevronLeft, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconChevronLeft, selector: "swirl-icon-chevron-left", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconChevronLeft = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconChevronLeft);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconChevronLeft, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-chevron-left',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconChevronRight = class SwirlIconChevronRight {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconChevronRight, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconChevronRight, selector: "swirl-icon-chevron-right", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconChevronRight = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconChevronRight);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconChevronRight, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-chevron-right',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconClose = class SwirlIconClose {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconClose, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconClose, selector: "swirl-icon-close", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconClose = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconClose);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconClose, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-close',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCloseFullscreen = class SwirlIconCloseFullscreen {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCloseFullscreen, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCloseFullscreen, selector: "swirl-icon-close-fullscreen", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCloseFullscreen = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCloseFullscreen);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCloseFullscreen, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-close-fullscreen',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCloseSmall = class SwirlIconCloseSmall {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCloseSmall, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCloseSmall, selector: "swirl-icon-close-small", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCloseSmall = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCloseSmall);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCloseSmall, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-close-small',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCloudUpload = class SwirlIconCloudUpload {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCloudUpload, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCloudUpload, selector: "swirl-icon-cloud-upload", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCloudUpload = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCloudUpload);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCloudUpload, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-cloud-upload',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconColumn = class SwirlIconColumn {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconColumn, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconColumn, selector: "swirl-icon-column", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconColumn = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconColumn);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconColumn, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-column',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconComment = class SwirlIconComment {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconComment, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconComment, selector: "swirl-icon-comment", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconComment = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconComment);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconComment, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-comment',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconContrast = class SwirlIconContrast {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconContrast, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconContrast, selector: "swirl-icon-contrast", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconContrast = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconContrast);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconContrast, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-contrast',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCopy = class SwirlIconCopy {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCopy, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCopy, selector: "swirl-icon-copy", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCopy = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCopy);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCopy, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-copy',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconCrop = class SwirlIconCrop {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCrop, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconCrop, selector: "swirl-icon-crop", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconCrop = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconCrop);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconCrop, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-crop',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDarkMode = class SwirlIconDarkMode {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDarkMode, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDarkMode, selector: "swirl-icon-dark-mode", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDarkMode = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDarkMode);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDarkMode, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-dark-mode',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDateRange = class SwirlIconDateRange {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDateRange, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDateRange, selector: "swirl-icon-date-range", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDateRange = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDateRange);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDateRange, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-date-range',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDelete = class SwirlIconDelete {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDelete, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDelete, selector: "swirl-icon-delete", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDelete = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDelete);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDelete, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-delete',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDeployedCode = class SwirlIconDeployedCode {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDeployedCode, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDeployedCode, selector: "swirl-icon-deployed-code", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDeployedCode = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDeployedCode);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDeployedCode, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-deployed-code',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDescription = class SwirlIconDescription {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDescription, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDescription, selector: "swirl-icon-description", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDescription = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDescription);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDescription, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-description',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDesktop = class SwirlIconDesktop {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDesktop, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDesktop, selector: "swirl-icon-desktop", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDesktop = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDesktop);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDesktop, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-desktop',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDirectory = class SwirlIconDirectory {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDirectory, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDirectory, selector: "swirl-icon-directory", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDirectory = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDirectory);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDirectory, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-directory',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDirectoryFilled = class SwirlIconDirectoryFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDirectoryFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDirectoryFilled, selector: "swirl-icon-directory-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDirectoryFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDirectoryFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDirectoryFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-directory-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDiscover = class SwirlIconDiscover {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDiscover, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDiscover, selector: "swirl-icon-discover", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDiscover = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDiscover);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDiscover, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-discover',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDockLeft = class SwirlIconDockLeft {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDockLeft, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDockLeft, selector: "swirl-icon-dock-left", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDockLeft = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDockLeft);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDockLeft, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-dock-left',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDockLeftCollapse = class SwirlIconDockLeftCollapse {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDockLeftCollapse, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDockLeftCollapse, selector: "swirl-icon-dock-left-collapse", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDockLeftCollapse = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDockLeftCollapse);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDockLeftCollapse, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-dock-left-collapse',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDockLeftExpand = class SwirlIconDockLeftExpand {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDockLeftExpand, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDockLeftExpand, selector: "swirl-icon-dock-left-expand", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDockLeftExpand = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDockLeftExpand);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDockLeftExpand, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-dock-left-expand',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDoorOpen = class SwirlIconDoorOpen {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDoorOpen, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDoorOpen, selector: "swirl-icon-door-open", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDoorOpen = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDoorOpen);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDoorOpen, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-door-open',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDot = class SwirlIconDot {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDot, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDot, selector: "swirl-icon-dot", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDot = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDot);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDot, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-dot',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDoubleArrowLeft = class SwirlIconDoubleArrowLeft {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDoubleArrowLeft, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDoubleArrowLeft, selector: "swirl-icon-double-arrow-left", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDoubleArrowLeft = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDoubleArrowLeft);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDoubleArrowLeft, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-double-arrow-left',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDoubleArrowRight = class SwirlIconDoubleArrowRight {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDoubleArrowRight, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDoubleArrowRight, selector: "swirl-icon-double-arrow-right", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDoubleArrowRight = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDoubleArrowRight);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDoubleArrowRight, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-double-arrow-right',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDownload = class SwirlIconDownload {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDownload, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDownload, selector: "swirl-icon-download", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDownload = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDownload);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDownload, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-download',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconDragHandle = class SwirlIconDragHandle {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDragHandle, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconDragHandle, selector: "swirl-icon-drag-handle", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconDragHandle = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconDragHandle);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconDragHandle, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-drag-handle',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconEdit = class SwirlIconEdit {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconEdit, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconEdit, selector: "swirl-icon-edit", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconEdit = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconEdit);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconEdit, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-edit',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconEditNote = class SwirlIconEditNote {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconEditNote, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconEditNote, selector: "swirl-icon-edit-note", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconEditNote = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconEditNote);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconEditNote, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-edit-note',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconEmojiMood = class SwirlIconEmojiMood {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconEmojiMood, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconEmojiMood, selector: "swirl-icon-emoji-mood", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconEmojiMood = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconEmojiMood);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconEmojiMood, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-emoji-mood',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconEmojiSatisfied = class SwirlIconEmojiSatisfied {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconEmojiSatisfied, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconEmojiSatisfied, selector: "swirl-icon-emoji-satisfied", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconEmojiSatisfied = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconEmojiSatisfied);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconEmojiSatisfied, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-emoji-satisfied',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconError = class SwirlIconError {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconError, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconError, selector: "swirl-icon-error", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconError = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconError);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconError, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-error',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconExpandLess = class SwirlIconExpandLess {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconExpandLess, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconExpandLess, selector: "swirl-icon-expand-less", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconExpandLess = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconExpandLess);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconExpandLess, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-expand-less',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconExpandMore = class SwirlIconExpandMore {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconExpandMore, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconExpandMore, selector: "swirl-icon-expand-more", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconExpandMore = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconExpandMore);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconExpandMore, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-expand-more',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconExperiment = class SwirlIconExperiment {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconExperiment, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconExperiment, selector: "swirl-icon-experiment", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconExperiment = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconExperiment);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconExperiment, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-experiment',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconFile = class SwirlIconFile {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFile, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconFile, selector: "swirl-icon-file", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconFile = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconFile);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFile, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-file',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconFileCopy = class SwirlIconFileCopy {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFileCopy, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconFileCopy, selector: "swirl-icon-file-copy", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconFileCopy = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconFileCopy);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFileCopy, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-file-copy',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconFilter = class SwirlIconFilter {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFilter, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconFilter, selector: "swirl-icon-filter", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconFilter = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconFilter);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFilter, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-filter',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconFolder = class SwirlIconFolder {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFolder, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconFolder, selector: "swirl-icon-folder", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconFolder = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconFolder);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFolder, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-folder',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconFolderShared = class SwirlIconFolderShared {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFolderShared, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconFolderShared, selector: "swirl-icon-folder-shared", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconFolderShared = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconFolderShared);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFolderShared, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-folder-shared',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconFormatHOne = class SwirlIconFormatHOne {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFormatHOne, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconFormatHOne, selector: "swirl-icon-format-h-one", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconFormatHOne = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconFormatHOne);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFormatHOne, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-format-h-one',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconFormatListBulleted = class SwirlIconFormatListBulleted {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFormatListBulleted, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconFormatListBulleted, selector: "swirl-icon-format-list-bulleted", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconFormatListBulleted = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconFormatListBulleted);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFormatListBulleted, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-format-list-bulleted',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconFullscreen = class SwirlIconFullscreen {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFullscreen, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconFullscreen, selector: "swirl-icon-fullscreen", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconFullscreen = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconFullscreen);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFullscreen, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-fullscreen',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconFullscreenExit = class SwirlIconFullscreenExit {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFullscreenExit, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconFullscreenExit, selector: "swirl-icon-fullscreen-exit", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconFullscreenExit = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconFullscreenExit);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconFullscreenExit, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-fullscreen-exit',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconGif = class SwirlIconGif {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconGif, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconGif, selector: "swirl-icon-gif", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconGif = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconGif);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconGif, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-gif',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconGroupAdd = class SwirlIconGroupAdd {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconGroupAdd, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconGroupAdd, selector: "swirl-icon-group-add", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconGroupAdd = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconGroupAdd);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconGroupAdd, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-group-add',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconGroupAssign = class SwirlIconGroupAssign {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconGroupAssign, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconGroupAssign, selector: "swirl-icon-group-assign", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconGroupAssign = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconGroupAssign);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconGroupAssign, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-group-assign',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconGroups = class SwirlIconGroups {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconGroups, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconGroups, selector: "swirl-icon-groups", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconGroups = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconGroups);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconGroups, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-groups',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconGroupsFilled = class SwirlIconGroupsFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconGroupsFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconGroupsFilled, selector: "swirl-icon-groups-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconGroupsFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconGroupsFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconGroupsFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-groups-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconHamburgerMenu = class SwirlIconHamburgerMenu {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHamburgerMenu, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconHamburgerMenu, selector: "swirl-icon-hamburger-menu", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconHamburgerMenu = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconHamburgerMenu);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHamburgerMenu, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-hamburger-menu',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconHealthAndSafety = class SwirlIconHealthAndSafety {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHealthAndSafety, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconHealthAndSafety, selector: "swirl-icon-health-and-safety", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconHealthAndSafety = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconHealthAndSafety);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHealthAndSafety, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-health-and-safety',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconHelp = class SwirlIconHelp {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHelp, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconHelp, selector: "swirl-icon-help", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconHelp = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconHelp);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHelp, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-help',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconHelpFilled = class SwirlIconHelpFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHelpFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconHelpFilled, selector: "swirl-icon-help-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconHelpFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconHelpFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHelpFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-help-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconHighlight = class SwirlIconHighlight {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHighlight, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconHighlight, selector: "swirl-icon-highlight", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconHighlight = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconHighlight);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHighlight, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-highlight',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconHistory = class SwirlIconHistory {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHistory, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconHistory, selector: "swirl-icon-history", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconHistory = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconHistory);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHistory, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-history',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconHome = class SwirlIconHome {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHome, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconHome, selector: "swirl-icon-home", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconHome = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconHome);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHome, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-home',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconHrResting = class SwirlIconHrResting {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHrResting, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconHrResting, selector: "swirl-icon-hr-resting", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconHrResting = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconHrResting);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconHrResting, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-hr-resting',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconImage = class SwirlIconImage {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconImage, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconImage, selector: "swirl-icon-image", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconImage = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconImage);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconImage, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-image',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconImproveText = class SwirlIconImproveText {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconImproveText, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconImproveText, selector: "swirl-icon-improve-text", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconImproveText = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconImproveText);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconImproveText, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-improve-text',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconInfo = class SwirlIconInfo {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconInfo, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconInfo, selector: "swirl-icon-info", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconInfo = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconInfo);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconInfo, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-info',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconInsertBelow = class SwirlIconInsertBelow {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconInsertBelow, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconInsertBelow, selector: "swirl-icon-insert-below", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconInsertBelow = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconInsertBelow);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconInsertBelow, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-insert-below',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconInsertChart = class SwirlIconInsertChart {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconInsertChart, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconInsertChart, selector: "swirl-icon-insert-chart", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconInsertChart = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconInsertChart);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconInsertChart, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-insert-chart',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconInsertOnTop = class SwirlIconInsertOnTop {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconInsertOnTop, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconInsertOnTop, selector: "swirl-icon-insert-on-top", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconInsertOnTop = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconInsertOnTop);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconInsertOnTop, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-insert-on-top',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconInventory = class SwirlIconInventory {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconInventory, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconInventory, selector: "swirl-icon-inventory", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconInventory = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconInventory);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconInventory, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-inventory',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconInventoryOff = class SwirlIconInventoryOff {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconInventoryOff, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconInventoryOff, selector: "swirl-icon-inventory-off", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconInventoryOff = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconInventoryOff);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconInventoryOff, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-inventory-off',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconIphone = class SwirlIconIphone {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconIphone, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconIphone, selector: "swirl-icon-iphone", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconIphone = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconIphone);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconIphone, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-iphone',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconKey = class SwirlIconKey {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconKey, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconKey, selector: "swirl-icon-key", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconKey = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconKey);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconKey, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-key',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconKeyboard = class SwirlIconKeyboard {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconKeyboard, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconKeyboard, selector: "swirl-icon-keyboard", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconKeyboard = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconKeyboard);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconKeyboard, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-keyboard',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconKeyboardHide = class SwirlIconKeyboardHide {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconKeyboardHide, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconKeyboardHide, selector: "swirl-icon-keyboard-hide", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconKeyboardHide = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconKeyboardHide);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconKeyboardHide, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-keyboard-hide',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconLightMode = class SwirlIconLightMode {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLightMode, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconLightMode, selector: "swirl-icon-light-mode", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconLightMode = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconLightMode);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLightMode, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-light-mode',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconLike = class SwirlIconLike {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLike, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconLike, selector: "swirl-icon-like", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconLike = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconLike);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLike, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-like',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconLink = class SwirlIconLink {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLink, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconLink, selector: "swirl-icon-link", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconLink = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconLink);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLink, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-link',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconLive = class SwirlIconLive {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLive, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconLive, selector: "swirl-icon-live", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconLive = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconLive);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLive, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-live',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconLoad = class SwirlIconLoad {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLoad, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconLoad, selector: "swirl-icon-load", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconLoad = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconLoad);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLoad, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-load',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconLocationOn = class SwirlIconLocationOn {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLocationOn, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconLocationOn, selector: "swirl-icon-location-on", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconLocationOn = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconLocationOn);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLocationOn, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-location-on',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconLock = class SwirlIconLock {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLock, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconLock, selector: "swirl-icon-lock", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconLock = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconLock);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLock, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-lock',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconLockOpen = class SwirlIconLockOpen {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLockOpen, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconLockOpen, selector: "swirl-icon-lock-open", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconLockOpen = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconLockOpen);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLockOpen, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-lock-open',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconLockPerson = class SwirlIconLockPerson {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLockPerson, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconLockPerson, selector: "swirl-icon-lock-person", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconLockPerson = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconLockPerson);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLockPerson, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-lock-person',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconLogin = class SwirlIconLogin {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLogin, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconLogin, selector: "swirl-icon-login", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconLogin = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconLogin);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLogin, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-login',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconLogout = class SwirlIconLogout {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLogout, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconLogout, selector: "swirl-icon-logout", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconLogout = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconLogout);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLogout, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-logout',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconLongText = class SwirlIconLongText {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLongText, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconLongText, selector: "swirl-icon-long-text", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconLongText = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconLongText);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconLongText, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-long-text',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMail = class SwirlIconMail {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMail, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMail, selector: "swirl-icon-mail", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMail = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMail);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMail, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-mail',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconManageAccounts = class SwirlIconManageAccounts {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconManageAccounts, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconManageAccounts, selector: "swirl-icon-manage-accounts", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconManageAccounts = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconManageAccounts);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconManageAccounts, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-manage-accounts',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMarkChatRead = class SwirlIconMarkChatRead {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMarkChatRead, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMarkChatRead, selector: "swirl-icon-mark-chat-read", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMarkChatRead = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMarkChatRead);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMarkChatRead, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-mark-chat-read',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMarkChatUnread = class SwirlIconMarkChatUnread {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMarkChatUnread, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMarkChatUnread, selector: "swirl-icon-mark-chat-unread", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMarkChatUnread = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMarkChatUnread);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMarkChatUnread, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-mark-chat-unread',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMention = class SwirlIconMention {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMention, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMention, selector: "swirl-icon-mention", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMention = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMention);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMention, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-mention',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMenu = class SwirlIconMenu {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMenu, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMenu, selector: "swirl-icon-menu", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMenu = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMenu);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMenu, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-menu',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMenuBook = class SwirlIconMenuBook {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMenuBook, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMenuBook, selector: "swirl-icon-menu-book", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMenuBook = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMenuBook);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMenuBook, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-menu-book',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMenuBookFilled = class SwirlIconMenuBookFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMenuBookFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMenuBookFilled, selector: "swirl-icon-menu-book-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMenuBookFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMenuBookFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMenuBookFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-menu-book-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMenuFilled = class SwirlIconMenuFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMenuFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMenuFilled, selector: "swirl-icon-menu-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMenuFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMenuFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMenuFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-menu-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMessage = class SwirlIconMessage {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMessage, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMessage, selector: "swirl-icon-message", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMessage = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMessage);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMessage, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-message',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMic = class SwirlIconMic {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMic, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMic, selector: "swirl-icon-mic", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMic = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMic);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMic, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-mic',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMicOff = class SwirlIconMicOff {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMicOff, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMicOff, selector: "swirl-icon-mic-off", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMicOff = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMicOff);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMicOff, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-mic-off',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMoreHorizontal = class SwirlIconMoreHorizontal {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMoreHorizontal, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMoreHorizontal, selector: "swirl-icon-more-horizontal", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMoreHorizontal = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMoreHorizontal);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMoreHorizontal, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-more-horizontal',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconMoreVertikal = class SwirlIconMoreVertikal {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMoreVertikal, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconMoreVertikal, selector: "swirl-icon-more-vertikal", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconMoreVertikal = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconMoreVertikal);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconMoreVertikal, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-more-vertikal',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconNews = class SwirlIconNews {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNews, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconNews, selector: "swirl-icon-news", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconNews = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconNews);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNews, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-news',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconNewsFilled = class SwirlIconNewsFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNewsFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconNewsFilled, selector: "swirl-icon-news-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconNewsFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconNewsFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNewsFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-news-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconNewsOff = class SwirlIconNewsOff {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNewsOff, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconNewsOff, selector: "swirl-icon-news-off", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconNewsOff = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconNewsOff);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNewsOff, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-news-off',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconNextPlan = class SwirlIconNextPlan {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNextPlan, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconNextPlan, selector: "swirl-icon-next-plan", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconNextPlan = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconNextPlan);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNextPlan, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-next-plan',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconNotifications = class SwirlIconNotifications {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNotifications, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconNotifications, selector: "swirl-icon-notifications", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconNotifications = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconNotifications);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNotifications, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-notifications',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconNotificationsActive = class SwirlIconNotificationsActive {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNotificationsActive, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconNotificationsActive, selector: "swirl-icon-notifications-active", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconNotificationsActive = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconNotificationsActive);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNotificationsActive, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-notifications-active',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconNotificationsOff = class SwirlIconNotificationsOff {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNotificationsOff, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconNotificationsOff, selector: "swirl-icon-notifications-off", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconNotificationsOff = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconNotificationsOff);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconNotificationsOff, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-notifications-off',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconOpenInFull = class SwirlIconOpenInFull {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconOpenInFull, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconOpenInFull, selector: "swirl-icon-open-in-full", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconOpenInFull = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconOpenInFull);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconOpenInFull, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-open-in-full',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconOpenInNew = class SwirlIconOpenInNew {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconOpenInNew, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconOpenInNew, selector: "swirl-icon-open-in-new", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconOpenInNew = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconOpenInNew);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconOpenInNew, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-open-in-new',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPause = class SwirlIconPause {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPause, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPause, selector: "swirl-icon-pause", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPause = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPause);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPause, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-pause',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPauseCircle = class SwirlIconPauseCircle {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPauseCircle, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPauseCircle, selector: "swirl-icon-pause-circle", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPauseCircle = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPauseCircle);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPauseCircle, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-pause-circle',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPeopleAlt = class SwirlIconPeopleAlt {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPeopleAlt, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPeopleAlt, selector: "swirl-icon-people-alt", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPeopleAlt = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPeopleAlt);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPeopleAlt, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-people-alt',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPerson = class SwirlIconPerson {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPerson, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPerson, selector: "swirl-icon-person", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPerson = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPerson);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPerson, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-person',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPersonOff = class SwirlIconPersonOff {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPersonOff, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPersonOff, selector: "swirl-icon-person-off", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPersonOff = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPersonOff);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPersonOff, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-person-off',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPhone = class SwirlIconPhone {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPhone, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPhone, selector: "swirl-icon-phone", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPhone = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPhone);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPhone, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-phone',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPhotoCamera = class SwirlIconPhotoCamera {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPhotoCamera, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPhotoCamera, selector: "swirl-icon-photo-camera", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPhotoCamera = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPhotoCamera);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPhotoCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-photo-camera',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPictureAsPdf = class SwirlIconPictureAsPdf {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPictureAsPdf, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPictureAsPdf, selector: "swirl-icon-picture-as-pdf", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPictureAsPdf = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPictureAsPdf);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPictureAsPdf, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-picture-as-pdf',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPictureInPicture = class SwirlIconPictureInPicture {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPictureInPicture, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPictureInPicture, selector: "swirl-icon-picture-in-picture", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPictureInPicture = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPictureInPicture);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPictureInPicture, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-picture-in-picture',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPin = class SwirlIconPin {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPin, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPin, selector: "swirl-icon-pin", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPin = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPin);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPin, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-pin',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPinOff = class SwirlIconPinOff {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPinOff, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPinOff, selector: "swirl-icon-pin-off", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPinOff = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPinOff);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPinOff, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-pin-off',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPlace = class SwirlIconPlace {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPlace, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPlace, selector: "swirl-icon-place", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPlace = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPlace);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPlace, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-place',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPlayArrow = class SwirlIconPlayArrow {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPlayArrow, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPlayArrow, selector: "swirl-icon-play-arrow", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPlayArrow = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPlayArrow);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPlayArrow, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-play-arrow',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPoll = class SwirlIconPoll {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPoll, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPoll, selector: "swirl-icon-poll", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPoll = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPoll);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPoll, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-poll',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPostApproval = class SwirlIconPostApproval {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPostApproval, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPostApproval, selector: "swirl-icon-post-approval", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPostApproval = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPostApproval);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPostApproval, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-post-approval',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPresent = class SwirlIconPresent {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPresent, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPresent, selector: "swirl-icon-present", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPresent = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPresent);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPresent, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-present',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPreview = class SwirlIconPreview {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPreview, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPreview, selector: "swirl-icon-preview", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPreview = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPreview);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPreview, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-preview',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPrint = class SwirlIconPrint {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPrint, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPrint, selector: "swirl-icon-print", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPrint = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPrint);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPrint, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-print',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPublic = class SwirlIconPublic {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPublic, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPublic, selector: "swirl-icon-public", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPublic = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPublic);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPublic, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-public',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPublicOff = class SwirlIconPublicOff {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPublicOff, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPublicOff, selector: "swirl-icon-public-off", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPublicOff = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPublicOff);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPublicOff, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-public-off',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconPublishedWithChanges = class SwirlIconPublishedWithChanges {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPublishedWithChanges, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconPublishedWithChanges, selector: "swirl-icon-published-with-changes", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconPublishedWithChanges = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconPublishedWithChanges);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconPublishedWithChanges, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-published-with-changes',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRatioFourToThree = class SwirlIconRatioFourToThree {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRatioFourToThree, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRatioFourToThree, selector: "swirl-icon-ratio-four-to-three", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRatioFourToThree = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRatioFourToThree);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRatioFourToThree, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-ratio-four-to-three',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRatioFreeform = class SwirlIconRatioFreeform {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRatioFreeform, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRatioFreeform, selector: "swirl-icon-ratio-freeform", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRatioFreeform = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRatioFreeform);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRatioFreeform, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-ratio-freeform',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRatioSixteenToNine = class SwirlIconRatioSixteenToNine {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRatioSixteenToNine, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRatioSixteenToNine, selector: "swirl-icon-ratio-sixteen-to-nine", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRatioSixteenToNine = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRatioSixteenToNine);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRatioSixteenToNine, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-ratio-sixteen-to-nine',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRatioSquare = class SwirlIconRatioSquare {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRatioSquare, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRatioSquare, selector: "swirl-icon-ratio-square", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRatioSquare = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRatioSquare);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRatioSquare, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-ratio-square',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRatioThreeToFour = class SwirlIconRatioThreeToFour {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRatioThreeToFour, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRatioThreeToFour, selector: "swirl-icon-ratio-three-to-four", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRatioThreeToFour = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRatioThreeToFour);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRatioThreeToFour, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-ratio-three-to-four',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRatioThreeToTwo = class SwirlIconRatioThreeToTwo {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRatioThreeToTwo, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRatioThreeToTwo, selector: "swirl-icon-ratio-three-to-two", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRatioThreeToTwo = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRatioThreeToTwo);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRatioThreeToTwo, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-ratio-three-to-two',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRecieved = class SwirlIconRecieved {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRecieved, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRecieved, selector: "swirl-icon-recieved", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRecieved = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRecieved);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRecieved, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-recieved',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRemove = class SwirlIconRemove {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRemove, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRemove, selector: "swirl-icon-remove", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRemove = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRemove);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRemove, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-remove',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRemoveCircle = class SwirlIconRemoveCircle {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRemoveCircle, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRemoveCircle, selector: "swirl-icon-remove-circle", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRemoveCircle = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRemoveCircle);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRemoveCircle, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-remove-circle',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRemoveModerator = class SwirlIconRemoveModerator {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRemoveModerator, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRemoveModerator, selector: "swirl-icon-remove-moderator", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRemoveModerator = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRemoveModerator);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRemoveModerator, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-remove-moderator',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconReply = class SwirlIconReply {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconReply, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconReply, selector: "swirl-icon-reply", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconReply = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconReply);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconReply, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-reply',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconReport = class SwirlIconReport {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconReport, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconReport, selector: "swirl-icon-report", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconReport = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconReport);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconReport, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-report',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRoadmap = class SwirlIconRoadmap {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRoadmap, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRoadmap, selector: "swirl-icon-roadmap", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRoadmap = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRoadmap);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRoadmap, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-roadmap',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRotateLeft = class SwirlIconRotateLeft {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRotateLeft, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRotateLeft, selector: "swirl-icon-rotate-left", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRotateLeft = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRotateLeft);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRotateLeft, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-rotate-left',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconRotateRight = class SwirlIconRotateRight {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRotateRight, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconRotateRight, selector: "swirl-icon-rotate-right", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconRotateRight = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconRotateRight);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconRotateRight, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-rotate-right',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconScreenshare = class SwirlIconScreenshare {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconScreenshare, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconScreenshare, selector: "swirl-icon-screenshare", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconScreenshare = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconScreenshare);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconScreenshare, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-screenshare',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconScreenshareOff = class SwirlIconScreenshareOff {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconScreenshareOff, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconScreenshareOff, selector: "swirl-icon-screenshare-off", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconScreenshareOff = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconScreenshareOff);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconScreenshareOff, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-screenshare-off',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconSearch = class SwirlIconSearch {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSearch, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconSearch, selector: "swirl-icon-search", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconSearch = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconSearch);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSearch, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-search',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconSearchStrong = class SwirlIconSearchStrong {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSearchStrong, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconSearchStrong, selector: "swirl-icon-search-strong", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconSearchStrong = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconSearchStrong);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSearchStrong, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-search-strong',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconSecure = class SwirlIconSecure {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSecure, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconSecure, selector: "swirl-icon-secure", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconSecure = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconSecure);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSecure, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-secure',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconSend = class SwirlIconSend {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSend, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconSend, selector: "swirl-icon-send", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconSend = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconSend);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSend, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-send',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconSettings = class SwirlIconSettings {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSettings, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconSettings, selector: "swirl-icon-settings", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconSettings = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconSettings);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSettings, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-settings',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconShortText = class SwirlIconShortText {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconShortText, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconShortText, selector: "swirl-icon-short-text", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconShortText = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconShortText);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconShortText, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-short-text',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconSimplify = class SwirlIconSimplify {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSimplify, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconSimplify, selector: "swirl-icon-simplify", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconSimplify = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconSimplify);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSimplify, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-simplify',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconSpellcheck = class SwirlIconSpellcheck {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSpellcheck, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconSpellcheck, selector: "swirl-icon-spellcheck", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconSpellcheck = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconSpellcheck);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSpellcheck, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-spellcheck',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconStars = class SwirlIconStars {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconStars, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconStars, selector: "swirl-icon-stars", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconStars = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconStars);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconStars, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-stars',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconStickyNote = class SwirlIconStickyNote {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconStickyNote, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconStickyNote, selector: "swirl-icon-sticky-note", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconStickyNote = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconStickyNote);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconStickyNote, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-sticky-note',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconStop = class SwirlIconStop {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconStop, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconStop, selector: "swirl-icon-stop", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconStop = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconStop);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconStop, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-stop',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconStopCircle = class SwirlIconStopCircle {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconStopCircle, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconStopCircle, selector: "swirl-icon-stop-circle", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconStopCircle = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconStopCircle);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconStopCircle, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-stop-circle',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconSunny = class SwirlIconSunny {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSunny, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconSunny, selector: "swirl-icon-sunny", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconSunny = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconSunny);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSunny, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-sunny',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconSync = class SwirlIconSync {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSync, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconSync, selector: "swirl-icon-sync", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconSync = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconSync);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconSync, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-sync',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconTasks = class SwirlIconTasks {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTasks, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconTasks, selector: "swirl-icon-tasks", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconTasks = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconTasks);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTasks, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-tasks',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconTasksFilled = class SwirlIconTasksFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTasksFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconTasksFilled, selector: "swirl-icon-tasks-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconTasksFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconTasksFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTasksFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-tasks-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconTerminal = class SwirlIconTerminal {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTerminal, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconTerminal, selector: "swirl-icon-terminal", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconTerminal = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconTerminal);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTerminal, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-terminal',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconTime = class SwirlIconTime {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTime, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconTime, selector: "swirl-icon-time", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconTime = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconTime);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTime, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-time',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconTimeFilled = class SwirlIconTimeFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTimeFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconTimeFilled, selector: "swirl-icon-time-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconTimeFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconTimeFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTimeFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-time-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconToday = class SwirlIconToday {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconToday, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconToday, selector: "swirl-icon-today", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconToday = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconToday);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconToday, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-today',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconTodayFilled = class SwirlIconTodayFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTodayFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconTodayFilled, selector: "swirl-icon-today-filled", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconTodayFilled = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconTodayFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTodayFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-today-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconTranslate = class SwirlIconTranslate {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTranslate, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconTranslate, selector: "swirl-icon-translate", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconTranslate = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconTranslate);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTranslate, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-translate',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconTreeStructure = class SwirlIconTreeStructure {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTreeStructure, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconTreeStructure, selector: "swirl-icon-tree-structure", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconTreeStructure = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconTreeStructure);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconTreeStructure, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-tree-structure',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconUndo = class SwirlIconUndo {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconUndo, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconUndo, selector: "swirl-icon-undo", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconUndo = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconUndo);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconUndo, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-undo',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconUnlockPerson = class SwirlIconUnlockPerson {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconUnlockPerson, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconUnlockPerson, selector: "swirl-icon-unlock-person", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconUnlockPerson = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconUnlockPerson);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconUnlockPerson, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-unlock-person',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconUpload = class SwirlIconUpload {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconUpload, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconUpload, selector: "swirl-icon-upload", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconUpload = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconUpload);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconUpload, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-upload',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconUserAdd = class SwirlIconUserAdd {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconUserAdd, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconUserAdd, selector: "swirl-icon-user-add", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconUserAdd = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconUserAdd);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconUserAdd, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-user-add',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconUserAssign = class SwirlIconUserAssign {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconUserAssign, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconUserAssign, selector: "swirl-icon-user-assign", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconUserAssign = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconUserAssign);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconUserAssign, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-user-assign',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconVideoCamera = class SwirlIconVideoCamera {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVideoCamera, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconVideoCamera, selector: "swirl-icon-video-camera", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconVideoCamera = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconVideoCamera);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVideoCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-video-camera',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconVideoCameraOff = class SwirlIconVideoCameraOff {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVideoCameraOff, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconVideoCameraOff, selector: "swirl-icon-video-camera-off", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconVideoCameraOff = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconVideoCameraOff);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVideoCameraOff, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-video-camera-off',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconVideoLibrary = class SwirlIconVideoLibrary {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVideoLibrary, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconVideoLibrary, selector: "swirl-icon-video-library", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconVideoLibrary = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconVideoLibrary);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVideoLibrary, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-video-library',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconVideoPlayer = class SwirlIconVideoPlayer {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVideoPlayer, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconVideoPlayer, selector: "swirl-icon-video-player", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconVideoPlayer = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconVideoPlayer);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVideoPlayer, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-video-player',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconViewAgenda = class SwirlIconViewAgenda {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconViewAgenda, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconViewAgenda, selector: "swirl-icon-view-agenda", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconViewAgenda = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconViewAgenda);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconViewAgenda, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-view-agenda',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconVisibility = class SwirlIconVisibility {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVisibility, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconVisibility, selector: "swirl-icon-visibility", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconVisibility = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconVisibility);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVisibility, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-visibility',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconVisibilityOff = class SwirlIconVisibilityOff {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVisibilityOff, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconVisibilityOff, selector: "swirl-icon-visibility-off", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconVisibilityOff = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconVisibilityOff);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVisibilityOff, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-visibility-off',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconVoice = class SwirlIconVoice {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVoice, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconVoice, selector: "swirl-icon-voice", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconVoice = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconVoice);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVoice, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-voice',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconVolumeUp = class SwirlIconVolumeUp {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVolumeUp, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconVolumeUp, selector: "swirl-icon-volume-up", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconVolumeUp = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconVolumeUp);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconVolumeUp, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-volume-up',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconWarning = class SwirlIconWarning {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconWarning, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconWarning, selector: "swirl-icon-warning", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconWarning = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconWarning);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconWarning, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-warning',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconWebAsset = class SwirlIconWebAsset {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconWebAsset, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconWebAsset, selector: "swirl-icon-web-asset", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconWebAsset = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconWebAsset);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconWebAsset, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-web-asset',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconWebAssetOff = class SwirlIconWebAssetOff {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconWebAssetOff, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconWebAssetOff, selector: "swirl-icon-web-asset-off", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconWebAssetOff = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconWebAssetOff);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconWebAssetOff, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-web-asset-off',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlIconWork = class SwirlIconWork {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconWork, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlIconWork, selector: "swirl-icon-work", inputs: { color: "color", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlIconWork = __decorate([
    ProxyCmp({
        inputs: ['color', 'size']
    })
], SwirlIconWork);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlIconWork, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-icon-work',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlImageGrid = class SwirlImageGrid {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlImageGrid, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlImageGrid, selector: "swirl-image-grid", inputs: { aspectRatio: "aspectRatio", borderRadius: "borderRadius", label: "label" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlImageGrid = __decorate([
    ProxyCmp({
        inputs: ['aspectRatio', 'borderRadius', 'label']
    })
], SwirlImageGrid);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlImageGrid, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-image-grid',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['aspectRatio', 'borderRadius', 'label'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlImageGridItem = class SwirlImageGridItem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['gifStarted', 'gifStopped', 'imageError', 'imageLoad']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlImageGridItem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlImageGridItem, selector: "swirl-image-grid-item", inputs: { alt: "alt", gifPauseLabel: "gifPauseLabel", gifPlayLabel: "gifPlayLabel", icon: "icon", interactive: "interactive", loading: "loading", overlay: "overlay", showGifControls: "showGifControls", src: "src" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlImageGridItem = __decorate([
    ProxyCmp({
        inputs: ['alt', 'gifPauseLabel', 'gifPlayLabel', 'icon', 'interactive', 'loading', 'overlay', 'showGifControls', 'src'],
        methods: ['play', 'pause']
    })
], SwirlImageGridItem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlImageGridItem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-image-grid-item',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['alt', 'gifPauseLabel', 'gifPlayLabel', 'icon', 'interactive', 'loading', 'overlay', 'showGifControls', 'src'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlInlineError = class SwirlInlineError {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlInlineError, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlInlineError, selector: "swirl-inline-error", inputs: { message: "message", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlInlineError = __decorate([
    ProxyCmp({
        inputs: ['message', 'size']
    })
], SwirlInlineError);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlInlineError, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-inline-error',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['message', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlInlineNotification = class SwirlInlineNotification {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlInlineNotification, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlInlineNotification, selector: "swirl-inline-notification", inputs: { heading: "heading", hideHeading: "hideHeading", importance: "importance", intent: "intent" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlInlineNotification = __decorate([
    ProxyCmp({
        inputs: ['heading', 'hideHeading', 'importance', 'intent']
    })
], SwirlInlineNotification);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlInlineNotification, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-inline-notification',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['heading', 'hideHeading', 'importance', 'intent'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlInlineStatus = class SwirlInlineStatus {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlInlineStatus, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlInlineStatus, selector: "swirl-inline-status", inputs: { icon: "icon", intent: "intent", message: "message", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlInlineStatus = __decorate([
    ProxyCmp({
        inputs: ['icon', 'intent', 'message', 'size']
    })
], SwirlInlineStatus);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlInlineStatus, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-inline-status',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['icon', 'intent', 'message', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlLightbox = class SwirlLightbox {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['activeSlideChange', 'lightboxClose']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlLightbox, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlLightbox, selector: "swirl-lightbox", inputs: { closeButtonLabel: "closeButtonLabel", downloadButtonEnabled: "downloadButtonEnabled", downloadButtonLabel: "downloadButtonLabel", hideMenu: "hideMenu", label: "label", menuLabel: "menuLabel", menuTriggerLabel: "menuTriggerLabel", nextSlideButtonLabel: "nextSlideButtonLabel", previousSlideButtonLabel: "previousSlideButtonLabel" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlLightbox = __decorate([
    ProxyCmp({
        inputs: ['closeButtonLabel', 'downloadButtonEnabled', 'downloadButtonLabel', 'hideMenu', 'label', 'menuLabel', 'menuTriggerLabel', 'nextSlideButtonLabel', 'previousSlideButtonLabel'],
        methods: ['open', 'close', 'activateSlide']
    })
], SwirlLightbox);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlLightbox, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-lightbox',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['closeButtonLabel', 'downloadButtonEnabled', 'downloadButtonLabel', 'hideMenu', 'label', 'menuLabel', 'menuTriggerLabel', 'nextSlideButtonLabel', 'previousSlideButtonLabel'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlLink = class SwirlLink {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlLink, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlLink, selector: "swirl-link", inputs: { color: "color", href: "href", label: "label", target: "target" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlLink = __decorate([
    ProxyCmp({
        inputs: ['color', 'href', 'label', 'target']
    })
], SwirlLink);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlLink, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-link',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['color', 'href', 'label', 'target'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlList = class SwirlList {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlList, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlList, selector: "swirl-list", ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlList = __decorate([
    ProxyCmp({})
], SwirlList);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlList, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-list',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: [],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlMenu = class SwirlMenu {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['done', 'valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlMenu, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlMenu, selector: "swirl-menu", inputs: { active: "active", label: "label", level: "level", mobileBackButtonLabel: "mobileBackButtonLabel", mobileCloseMenuButtonLabel: "mobileCloseMenuButtonLabel", mobileDoneButtonLabel: "mobileDoneButtonLabel", value: "value", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlMenu = __decorate([
    ProxyCmp({
        inputs: ['active', 'label', 'level', 'mobileBackButtonLabel', 'mobileCloseMenuButtonLabel', 'mobileDoneButtonLabel', 'value', 'variant'],
        methods: ['activateMenuItem', 'close', 'goBack', 'focusFirstItem', 'focusItemAtIndex', 'updateSelection', 'updateActiveItem']
    })
], SwirlMenu);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlMenu, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-menu',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['active', 'label', 'level', 'mobileBackButtonLabel', 'mobileCloseMenuButtonLabel', 'mobileDoneButtonLabel', 'value', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlMenuItem = class SwirlMenuItem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlMenuItem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlMenuItem, selector: "swirl-menu-item", inputs: { description: "description", disabled: "disabled", expanded: "expanded", icon: "icon", iconBadge: "iconBadge", intent: "intent", label: "label", suffix: "suffix", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlMenuItem = __decorate([
    ProxyCmp({
        inputs: ['description', 'disabled', 'expanded', 'icon', 'iconBadge', 'intent', 'label', 'suffix', 'value'],
        methods: ['getSubMenu', 'updateValue', 'getParentMenu']
    })
], SwirlMenuItem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlMenuItem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-menu-item',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['description', 'disabled', 'expanded', 'icon', 'iconBadge', 'intent', 'label', 'suffix', 'value'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlModal = class SwirlModal {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['toggleFullscreen', 'modalClose', 'modalOpen', 'primaryAction', 'requestModalClose', 'secondaryAction', 'sidebarClose']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlModal, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlModal, selector: "swirl-modal", inputs: { closable: "closable", closeButtonLabel: "closeButtonLabel", contentGap: "contentGap", fullscreenDisableButtonLabel: "fullscreenDisableButtonLabel", fullscreenEnableButtonLabel: "fullscreenEnableButtonLabel", hasSidebarCloseButton: "hasSidebarCloseButton", height: "height", hideCloseButton: "hideCloseButton", hideLabel: "hideLabel", hideSecondaryContent: "hideSecondaryContent", hideSecondaryContentBorders: "hideSecondaryContentBorders", hideSidebarContent: "hideSidebarContent", label: "label", maxHeight: "maxHeight", maxWidth: "maxWidth", minHeight: "minHeight", padded: "padded", primaryActionLabel: "primaryActionLabel", primaryContentFlex: "primaryContentFlex", primaryContentMaxWidth: "primaryContentMaxWidth", secondaryActionLabel: "secondaryActionLabel", secondaryContentFlex: "secondaryContentFlex", secondaryContentMaxWidth: "secondaryContentMaxWidth", secondaryContentPadding: "secondaryContentPadding", secondaryContentPaddingBlockEnd: "secondaryContentPaddingBlockEnd", secondaryContentPaddingBlockStart: "secondaryContentPaddingBlockStart", secondaryContentPaddingInlineEnd: "secondaryContentPaddingInlineEnd", secondaryContentPaddingInlineStart: "secondaryContentPaddingInlineStart", showFullscreenButton: "showFullscreenButton", sidebarCloseButtonLabel: "sidebarCloseButtonLabel", sidebarFooterPadded: "sidebarFooterPadded", sidebarLabel: "sidebarLabel", sidebarPadded: "sidebarPadded", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlModal = __decorate([
    ProxyCmp({
        inputs: ['closable', 'closeButtonLabel', 'contentGap', 'fullscreenDisableButtonLabel', 'fullscreenEnableButtonLabel', 'hasSidebarCloseButton', 'height', 'hideCloseButton', 'hideLabel', 'hideSecondaryContent', 'hideSecondaryContentBorders', 'hideSidebarContent', 'label', 'maxHeight', 'maxWidth', 'minHeight', 'padded', 'primaryActionLabel', 'primaryContentFlex', 'primaryContentMaxWidth', 'secondaryActionLabel', 'secondaryContentFlex', 'secondaryContentMaxWidth', 'secondaryContentPadding', 'secondaryContentPaddingBlockEnd', 'secondaryContentPaddingBlockStart', 'secondaryContentPaddingInlineEnd', 'secondaryContentPaddingInlineStart', 'showFullscreenButton', 'sidebarCloseButtonLabel', 'sidebarFooterPadded', 'sidebarLabel', 'sidebarPadded', 'variant'],
        methods: ['open', 'close', 'setFullscreen']
    })
], SwirlModal);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlModal, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-modal',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['closable', 'closeButtonLabel', 'contentGap', 'fullscreenDisableButtonLabel', 'fullscreenEnableButtonLabel', 'hasSidebarCloseButton', 'height', 'hideCloseButton', 'hideLabel', 'hideSecondaryContent', 'hideSecondaryContentBorders', 'hideSidebarContent', 'label', 'maxHeight', 'maxWidth', 'minHeight', 'padded', 'primaryActionLabel', 'primaryContentFlex', 'primaryContentMaxWidth', 'secondaryActionLabel', 'secondaryContentFlex', 'secondaryContentMaxWidth', 'secondaryContentPadding', 'secondaryContentPaddingBlockEnd', 'secondaryContentPaddingBlockStart', 'secondaryContentPaddingInlineEnd', 'secondaryContentPaddingInlineStart', 'showFullscreenButton', 'sidebarCloseButtonLabel', 'sidebarFooterPadded', 'sidebarLabel', 'sidebarPadded', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlOptionList = class SwirlOptionList {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['itemDrop', 'valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlOptionList, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlOptionList, selector: "swirl-option-list", inputs: { allowDeselect: "allowDeselect", allowDrag: "allowDrag", assistiveTextItemGrabbed: "assistiveTextItemGrabbed", assistiveTextItemMoved: "assistiveTextItemMoved", assistiveTextItemMoving: "assistiveTextItemMoving", disabled: "disabled", label: "label", multiSelect: "multiSelect", optionListId: "optionListId", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlOptionList = __decorate([
    ProxyCmp({
        inputs: ['allowDeselect', 'allowDrag', 'assistiveTextItemGrabbed', 'assistiveTextItemMoved', 'assistiveTextItemMoving', 'disabled', 'label', 'multiSelect', 'optionListId', 'value']
    })
], SwirlOptionList);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlOptionList, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-option-list',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['allowDeselect', 'allowDrag', 'assistiveTextItemGrabbed', 'assistiveTextItemMoved', 'assistiveTextItemMoving', 'disabled', 'label', 'multiSelect', 'optionListId', 'value'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlOptionListItem = class SwirlOptionListItem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['toggleDrag']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlOptionListItem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlOptionListItem, selector: "swirl-option-list-item", inputs: { allowDrag: "allowDrag", context: "context", description: "description", disabled: "disabled", dragHandleDescription: "dragHandleDescription", dragHandleLabel: "dragHandleLabel", dragging: "dragging", icon: "icon", iconBadge: "iconBadge", label: "label", selected: "selected", swirlAriaRole: "swirlAriaRole", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlOptionListItem = __decorate([
    ProxyCmp({
        inputs: ['allowDrag', 'context', 'description', 'disabled', 'dragHandleDescription', 'dragHandleLabel', 'dragging', 'icon', 'iconBadge', 'label', 'selected', 'swirlAriaRole', 'value']
    })
], SwirlOptionListItem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlOptionListItem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-option-list-item',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['allowDrag', 'context', 'description', 'disabled', 'dragHandleDescription', 'dragHandleLabel', 'dragging', 'icon', 'iconBadge', 'label', 'selected', 'swirlAriaRole', 'value'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlOptionListSection = class SwirlOptionListSection {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlOptionListSection, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlOptionListSection, selector: "swirl-option-list-section", inputs: { hasSeparator: "hasSeparator", label: "label", separatorSpacing: "separatorSpacing", spacing: "spacing" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlOptionListSection = __decorate([
    ProxyCmp({
        inputs: ['hasSeparator', 'label', 'separatorSpacing', 'spacing']
    })
], SwirlOptionListSection);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlOptionListSection, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-option-list-section',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['hasSeparator', 'label', 'separatorSpacing', 'spacing'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlPagination = class SwirlPagination {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['setPage', 'setPageSize']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlPagination, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlPagination, selector: "swirl-pagination", inputs: { firstPageButtonLabel: "firstPageButtonLabel", label: "label", lastPageButtonLabel: "lastPageButtonLabel", nextButtonLabel: "nextButtonLabel", page: "page", pageLabel: "pageLabel", pageSelectLabel: "pageSelectLabel", pageSize: "pageSize", pageSizeOptions: "pageSizeOptions", pageSizeSelectLabel: "pageSizeSelectLabel", pages: "pages", prevButtonLabel: "prevButtonLabel", showPageSizeSelect: "showPageSizeSelect", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlPagination = __decorate([
    ProxyCmp({
        inputs: ['firstPageButtonLabel', 'label', 'lastPageButtonLabel', 'nextButtonLabel', 'page', 'pageLabel', 'pageSelectLabel', 'pageSize', 'pageSizeOptions', 'pageSizeSelectLabel', 'pages', 'prevButtonLabel', 'showPageSizeSelect', 'variant']
    })
], SwirlPagination);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlPagination, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-pagination',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['firstPageButtonLabel', 'label', 'lastPageButtonLabel', 'nextButtonLabel', 'page', 'pageLabel', 'pageSelectLabel', 'pageSize', 'pageSizeOptions', 'pageSizeSelectLabel', 'pages', 'prevButtonLabel', 'showPageSizeSelect', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlPdfReader = class SwirlPdfReader {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['modalClose', 'modalOpen']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlPdfReader, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlPdfReader, selector: "swirl-pdf-reader", inputs: { autoZoomLabel: "autoZoomLabel", closeButtonLabel: "closeButtonLabel", downloadButtonEnabled: "downloadButtonEnabled", downloadButtonLabel: "downloadButtonLabel", file: "file", fileName: "fileName", fileTypeLabel: "fileTypeLabel", label: "label", menuLabel: "menuLabel", menuTriggerLabel: "menuTriggerLabel", pdfWorkerSrc: "pdfWorkerSrc", printButtonEnabled: "printButtonEnabled", printButtonLabel: "printButtonLabel", sideBySideButtonLabel: "sideBySideButtonLabel", skipNativeDownload: "skipNativeDownload", thumbnailButtonLabel: "thumbnailButtonLabel", thumbnailsButtonLabel: "thumbnailsButtonLabel", thumbnailsLabel: "thumbnailsLabel", zoomInButtonLabel: "zoomInButtonLabel", zoomOutButtonLabel: "zoomOutButtonLabel", zoomSelectLabel: "zoomSelectLabel" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlPdfReader = __decorate([
    ProxyCmp({
        inputs: ['autoZoomLabel', 'closeButtonLabel', 'downloadButtonEnabled', 'downloadButtonLabel', 'file', 'fileName', 'fileTypeLabel', 'label', 'menuLabel', 'menuTriggerLabel', 'pdfWorkerSrc', 'printButtonEnabled', 'printButtonLabel', 'sideBySideButtonLabel', 'skipNativeDownload', 'thumbnailButtonLabel', 'thumbnailsButtonLabel', 'thumbnailsLabel', 'zoomInButtonLabel', 'zoomOutButtonLabel', 'zoomSelectLabel'],
        methods: ['open', 'close']
    })
], SwirlPdfReader);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlPdfReader, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-pdf-reader',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['autoZoomLabel', 'closeButtonLabel', 'downloadButtonEnabled', 'downloadButtonLabel', 'file', 'fileName', 'fileTypeLabel', 'label', 'menuLabel', 'menuTriggerLabel', 'pdfWorkerSrc', 'printButtonEnabled', 'printButtonLabel', 'sideBySideButtonLabel', 'skipNativeDownload', 'thumbnailButtonLabel', 'thumbnailsButtonLabel', 'thumbnailsLabel', 'zoomInButtonLabel', 'zoomOutButtonLabel', 'zoomSelectLabel'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlPopover = class SwirlPopover {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['popoverClose', 'popoverOpen']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlPopover, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlPopover, selector: "swirl-popover", inputs: { animation: "animation", disableScrollLock: "disableScrollLock", enableFlip: "enableFlip", fullscreenBottomSheet: "fullscreenBottomSheet", label: "label", maxHeight: "maxHeight", offset: "offset", padded: "padded", placement: "placement", popoverId: "popoverId", returnFocusToTrigger: "returnFocusToTrigger", transparent: "transparent", trigger: "trigger", triggerContainer: "triggerContainer", useContainerWidth: "useContainerWidth" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlPopover = __decorate([
    ProxyCmp({
        inputs: ['animation', 'disableScrollLock', 'enableFlip', 'fullscreenBottomSheet', 'label', 'maxHeight', 'offset', 'padded', 'placement', 'popoverId', 'returnFocusToTrigger', 'transparent', 'trigger', 'triggerContainer', 'useContainerWidth'],
        methods: ['close', 'open', 'isOpen']
    })
], SwirlPopover);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlPopover, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-popover',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['animation', 'disableScrollLock', 'enableFlip', 'fullscreenBottomSheet', 'label', 'maxHeight', 'offset', 'padded', 'placement', 'popoverId', 'returnFocusToTrigger', 'transparent', 'trigger', 'triggerContainer', 'useContainerWidth'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlPopoverTrigger = class SwirlPopoverTrigger {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlPopoverTrigger, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlPopoverTrigger, selector: "swirl-popover-trigger", inputs: { hidePopoverWhenInvisible: "hidePopoverWhenInvisible", hoverDelay: "hoverDelay", hoverLingerDuration: "hoverLingerDuration", parentScrollContainer: "parentScrollContainer", setAriaAttributes: "setAriaAttributes", swirlPopover: "swirlPopover", triggerOnClick: "triggerOnClick", triggerOnHover: "triggerOnHover" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlPopoverTrigger = __decorate([
    ProxyCmp({
        inputs: ['hidePopoverWhenInvisible', 'hoverDelay', 'hoverLingerDuration', 'parentScrollContainer', 'setAriaAttributes', 'swirlPopover', 'triggerOnClick', 'triggerOnHover']
    })
], SwirlPopoverTrigger);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlPopoverTrigger, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-popover-trigger',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['hidePopoverWhenInvisible', 'hoverDelay', 'hoverLingerDuration', 'parentScrollContainer', 'setAriaAttributes', 'swirlPopover', 'triggerOnClick', 'triggerOnHover'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlProgressIndicator = class SwirlProgressIndicator {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlProgressIndicator, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlProgressIndicator, selector: "swirl-progress-indicator", inputs: { label: "label", size: "size", value: "value", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlProgressIndicator = __decorate([
    ProxyCmp({
        inputs: ['label', 'size', 'value', 'variant']
    })
], SwirlProgressIndicator);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlProgressIndicator, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-progress-indicator',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['label', 'size', 'value', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlRadio = class SwirlRadio {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlRadio, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlRadio, selector: "swirl-radio", inputs: { checked: "checked", description: "description", disabled: "disabled", inputId: "inputId", inputName: "inputName", invalid: "invalid", label: "label", tooltip: "tooltip", value: "value", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlRadio = __decorate([
    ProxyCmp({
        inputs: ['checked', 'description', 'disabled', 'inputId', 'inputName', 'invalid', 'label', 'tooltip', 'value', 'variant']
    })
], SwirlRadio);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlRadio, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-radio',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['checked', 'description', 'disabled', 'inputId', 'inputName', 'invalid', 'label', 'tooltip', 'value', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlRadioGroup = class SwirlRadioGroup {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlRadioGroup, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlRadioGroup, selector: "swirl-radio-group", inputs: { swirlAriaDescribedby: "swirlAriaDescribedby", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlRadioGroup = __decorate([
    ProxyCmp({
        inputs: ['swirlAriaDescribedby', 'value']
    })
], SwirlRadioGroup);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlRadioGroup, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-radio-group',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['swirlAriaDescribedby', 'value'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlResourceList = class SwirlResourceList {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['itemDrop']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlResourceList, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlResourceList, selector: "swirl-resource-list", inputs: { allowDrag: "allowDrag", assistiveTextItemGrabbed: "assistiveTextItemGrabbed", assistiveTextItemMoved: "assistiveTextItemMoved", assistiveTextItemMoving: "assistiveTextItemMoving", controllingElement: "controllingElement", label: "label", padding: "padding", paddingBlockEnd: "paddingBlockEnd", paddingBlockStart: "paddingBlockStart", paddingInlineEnd: "paddingInlineEnd", paddingInlineStart: "paddingInlineStart", semantics: "semantics", spacing: "spacing" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlResourceList = __decorate([
    ProxyCmp({
        inputs: ['allowDrag', 'assistiveTextItemGrabbed', 'assistiveTextItemMoved', 'assistiveTextItemMoving', 'controllingElement', 'label', 'padding', 'paddingBlockEnd', 'paddingBlockStart', 'paddingInlineEnd', 'paddingInlineStart', 'semantics', 'spacing']
    })
], SwirlResourceList);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlResourceList, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-resource-list',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['allowDrag', 'assistiveTextItemGrabbed', 'assistiveTextItemMoved', 'assistiveTextItemMoving', 'controllingElement', 'label', 'padding', 'paddingBlockEnd', 'paddingBlockStart', 'paddingInlineEnd', 'paddingInlineStart', 'semantics', 'spacing'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlResourceListFileItem = class SwirlResourceListFileItem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['remove']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlResourceListFileItem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlResourceListFileItem, selector: "swirl-resource-list-file-item", inputs: { description: "description", errorMessage: "errorMessage", icon: "icon", label: "label", loading: "loading", removable: "removable", removeButtonLabel: "removeButtonLabel" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlResourceListFileItem = __decorate([
    ProxyCmp({
        inputs: ['description', 'errorMessage', 'icon', 'label', 'loading', 'removable', 'removeButtonLabel']
    })
], SwirlResourceListFileItem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlResourceListFileItem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-resource-list-file-item',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['description', 'errorMessage', 'icon', 'label', 'loading', 'removable', 'removeButtonLabel'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlResourceListItem = class SwirlResourceListItem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['toggleDrag', 'valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlResourceListItem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlResourceListItem, selector: "swirl-resource-list-item", inputs: { active: "active", allowDrag: "allowDrag", allowHtml: "allowHtml", checked: "checked", compact: "compact", description: "description", descriptionWrap: "descriptionWrap", disabled: "disabled", dragHandleDescription: "dragHandleDescription", dragHandleLabel: "dragHandleLabel", dragging: "dragging", hideDivider: "hideDivider", href: "href", interactive: "interactive", label: "label", labelMinHeight: "labelMinHeight", labelWeight: "labelWeight", labelWrap: "labelWrap", menuTriggerId: "menuTriggerId", menuTriggerLabel: "menuTriggerLabel", meta: "meta", selectable: "selectable", swirlAriaLabel: "swirlAriaLabel", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlResourceListItem = __decorate([
    ProxyCmp({
        inputs: ['active', 'allowDrag', 'allowHtml', 'checked', 'compact', 'description', 'descriptionWrap', 'disabled', 'dragHandleDescription', 'dragHandleLabel', 'dragging', 'hideDivider', 'href', 'interactive', 'label', 'labelMinHeight', 'labelWeight', 'labelWrap', 'menuTriggerId', 'menuTriggerLabel', 'meta', 'selectable', 'swirlAriaLabel', 'value']
    })
], SwirlResourceListItem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlResourceListItem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-resource-list-item',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['active', 'allowDrag', 'allowHtml', 'checked', 'compact', 'description', 'descriptionWrap', 'disabled', 'dragHandleDescription', 'dragHandleLabel', 'dragging', 'hideDivider', 'href', 'interactive', 'label', 'labelMinHeight', 'labelWeight', 'labelWrap', 'menuTriggerId', 'menuTriggerLabel', 'meta', 'selectable', 'swirlAriaLabel', 'value'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlResourceListSection = class SwirlResourceListSection {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlResourceListSection, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlResourceListSection, selector: "swirl-resource-list-section", inputs: { hasSeparator: "hasSeparator", label: "label", separatorSpacing: "separatorSpacing", spacing: "spacing" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlResourceListSection = __decorate([
    ProxyCmp({
        inputs: ['hasSeparator', 'label', 'separatorSpacing', 'spacing']
    })
], SwirlResourceListSection);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlResourceListSection, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-resource-list-section',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['hasSeparator', 'label', 'separatorSpacing', 'spacing'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSearch = class SwirlSearch {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['inputBlur', 'inputFocus', 'inputInput', 'valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSearch, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSearch, selector: "swirl-search", inputs: { autoFocus: "autoFocus", clearButtonLabel: "clearButtonLabel", disabled: "disabled", inputId: "inputId", inputName: "inputName", label: "label", placeholder: "placeholder", value: "value", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSearch = __decorate([
    ProxyCmp({
        inputs: ['autoFocus', 'clearButtonLabel', 'disabled', 'inputId', 'inputName', 'label', 'placeholder', 'value', 'variant']
    })
], SwirlSearch);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSearch, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-search',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['autoFocus', 'clearButtonLabel', 'disabled', 'inputId', 'inputName', 'label', 'placeholder', 'value', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSelect = class SwirlSelect {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['searchChange', 'valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSelect, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSelect, selector: "swirl-select", inputs: { allowDeselect: "allowDeselect", disabled: "disabled", emptyListLabel: "emptyListLabel", inline: "inline", invalid: "invalid", label: "label", multiSelect: "multiSelect", required: "required", searchInputLabel: "searchInputLabel", searchLoading: "searchLoading", searchPlaceholder: "searchPlaceholder", selectId: "selectId", standalone: "standalone", swirlAriaDescribedby: "swirlAriaDescribedby", value: "value", withSearch: "withSearch" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSelect = __decorate([
    ProxyCmp({
        inputs: ['allowDeselect', 'disabled', 'emptyListLabel', 'inline', 'invalid', 'label', 'multiSelect', 'required', 'searchInputLabel', 'searchLoading', 'searchPlaceholder', 'selectId', 'standalone', 'swirlAriaDescribedby', 'value', 'withSearch']
    })
], SwirlSelect);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSelect, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-select',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['allowDeselect', 'disabled', 'emptyListLabel', 'inline', 'invalid', 'label', 'multiSelect', 'required', 'searchInputLabel', 'searchLoading', 'searchPlaceholder', 'selectId', 'standalone', 'swirlAriaDescribedby', 'value', 'withSearch'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSeparator = class SwirlSeparator {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSeparator, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSeparator, selector: "swirl-separator", inputs: { borderColor: "borderColor", color: "color", label: "label", orientation: "orientation", spacing: "spacing" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSeparator = __decorate([
    ProxyCmp({
        inputs: ['borderColor', 'color', 'label', 'orientation', 'spacing']
    })
], SwirlSeparator);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSeparator, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-separator',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['borderColor', 'color', 'label', 'orientation', 'spacing'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlShellLayout = class SwirlShellLayout {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['sidebarToggleClick', 'skipLinkClick']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlShellLayout, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlShellLayout, selector: "swirl-shell-layout", inputs: { brandedHeader: "brandedHeader", browserBackButtonLabel: "browserBackButtonLabel", browserForwardButtonLabel: "browserForwardButtonLabel", collapseNavigationButtonLabel: "collapseNavigationButtonLabel", enableSecondaryNavGridLayout: "enableSecondaryNavGridLayout", expandNavigationButtonLabel: "expandNavigationButtonLabel", gridNavLayoutToggleLabel: "gridNavLayoutToggleLabel", hideMobileNavigationButtonLabel: "hideMobileNavigationButtonLabel", listNavLayoutToggleLabel: "listNavLayoutToggleLabel", navigationLabel: "navigationLabel", secondaryNavCollapseLabel: "secondaryNavCollapseLabel", secondaryNavExpandLabel: "secondaryNavExpandLabel", sidebarActive: "sidebarActive", sidebarToggleBadge: "sidebarToggleBadge", sidebarToggleBadgeAriaLabel: "sidebarToggleBadgeAriaLabel", sidebarToggleIcon: "sidebarToggleIcon", sidebarToggleLabel: "sidebarToggleLabel", skipLinkLabel: "skipLinkLabel" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlShellLayout = __decorate([
    ProxyCmp({
        inputs: ['brandedHeader', 'browserBackButtonLabel', 'browserForwardButtonLabel', 'collapseNavigationButtonLabel', 'enableSecondaryNavGridLayout', 'expandNavigationButtonLabel', 'gridNavLayoutToggleLabel', 'hideMobileNavigationButtonLabel', 'listNavLayoutToggleLabel', 'navigationLabel', 'secondaryNavCollapseLabel', 'secondaryNavExpandLabel', 'sidebarActive', 'sidebarToggleBadge', 'sidebarToggleBadgeAriaLabel', 'sidebarToggleIcon', 'sidebarToggleLabel', 'skipLinkLabel'],
        methods: ['showMobileNavigation', 'hideMobileNavigation']
    })
], SwirlShellLayout);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlShellLayout, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-shell-layout',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['brandedHeader', 'browserBackButtonLabel', 'browserForwardButtonLabel', 'collapseNavigationButtonLabel', 'enableSecondaryNavGridLayout', 'expandNavigationButtonLabel', 'gridNavLayoutToggleLabel', 'hideMobileNavigationButtonLabel', 'listNavLayoutToggleLabel', 'navigationLabel', 'secondaryNavCollapseLabel', 'secondaryNavExpandLabel', 'sidebarActive', 'sidebarToggleBadge', 'sidebarToggleBadgeAriaLabel', 'sidebarToggleIcon', 'sidebarToggleLabel', 'skipLinkLabel'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlShellNavigationItem = class SwirlShellNavigationItem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlShellNavigationItem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlShellNavigationItem, selector: "swirl-shell-navigation-item", inputs: { active: "active", badgeLabel: "badgeLabel", boxed: "boxed", hideLabel: "hideLabel", href: "href", inlineLabel: "inlineLabel", inlineLabelColor: "inlineLabelColor", label: "label", target: "target", tiled: "tiled", withGradient: "withGradient" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlShellNavigationItem = __decorate([
    ProxyCmp({
        inputs: ['active', 'badgeLabel', 'boxed', 'hideLabel', 'href', 'inlineLabel', 'inlineLabelColor', 'label', 'target', 'tiled', 'withGradient']
    })
], SwirlShellNavigationItem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlShellNavigationItem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-shell-navigation-item',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['active', 'badgeLabel', 'boxed', 'hideLabel', 'href', 'inlineLabel', 'inlineLabelColor', 'label', 'target', 'tiled', 'withGradient'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSkeletonBox = class SwirlSkeletonBox {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSkeletonBox, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSkeletonBox, selector: "swirl-skeleton-box", inputs: { animated: "animated", aspectRatio: "aspectRatio", borderRadius: "borderRadius", height: "height", width: "width" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSkeletonBox = __decorate([
    ProxyCmp({
        inputs: ['animated', 'aspectRatio', 'borderRadius', 'height', 'width']
    })
], SwirlSkeletonBox);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSkeletonBox, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-skeleton-box',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['animated', 'aspectRatio', 'borderRadius', 'height', 'width'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSkeletonText = class SwirlSkeletonText {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSkeletonText, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSkeletonText, selector: "swirl-skeleton-text", inputs: { animated: "animated", lines: "lines", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSkeletonText = __decorate([
    ProxyCmp({
        inputs: ['animated', 'lines', 'size']
    })
], SwirlSkeletonText);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSkeletonText, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-skeleton-text',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['animated', 'lines', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSpinner = class SwirlSpinner {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSpinner, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSpinner, selector: "swirl-spinner", inputs: { label: "label", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSpinner = __decorate([
    ProxyCmp({
        inputs: ['label', 'size']
    })
], SwirlSpinner);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSpinner, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-spinner',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['label', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlStack = class SwirlStack {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlStack, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlStack, selector: "swirl-stack", inputs: { align: "align", as: "as", columnSpacing: "columnSpacing", height: "height", justify: "justify", orientation: "orientation", rowSpacing: "rowSpacing", spacing: "spacing", swirlAriaRole: "swirlAriaRole", wrap: "wrap" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlStack = __decorate([
    ProxyCmp({
        inputs: ['align', 'as', 'columnSpacing', 'height', 'justify', 'orientation', 'rowSpacing', 'spacing', 'swirlAriaRole', 'wrap']
    })
], SwirlStack);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlStack, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-stack',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['align', 'as', 'columnSpacing', 'height', 'justify', 'orientation', 'rowSpacing', 'spacing', 'swirlAriaRole', 'wrap'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlStatusIndicator = class SwirlStatusIndicator {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlStatusIndicator, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlStatusIndicator, selector: "swirl-status-indicator", inputs: { intent: "intent", label: "label" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlStatusIndicator = __decorate([
    ProxyCmp({
        inputs: ['intent', 'label']
    })
], SwirlStatusIndicator);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlStatusIndicator, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-status-indicator',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['intent', 'label'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSwitch = class SwirlSwitch {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSwitch, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSwitch, selector: "swirl-switch", inputs: { checked: "checked", disabled: "disabled", hideLabel: "hideLabel", inputId: "inputId", inputName: "inputName", label: "label", labelPosition: "labelPosition", swirlAriaLabel: "swirlAriaLabel", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSwitch = __decorate([
    ProxyCmp({
        inputs: ['checked', 'disabled', 'hideLabel', 'inputId', 'inputName', 'label', 'labelPosition', 'swirlAriaLabel', 'value'],
        methods: ['toggle']
    })
], SwirlSwitch);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSwitch, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-switch',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['checked', 'disabled', 'hideLabel', 'inputId', 'inputName', 'label', 'labelPosition', 'swirlAriaLabel', 'value'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbol = class SwirlSymbol {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbol, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbol, selector: "swirl-symbol", inputs: { glyph: "glyph", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbol = __decorate([
    ProxyCmp({
        inputs: ['glyph', 'size']
    })
], SwirlSymbol);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbol, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['glyph', 'size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolAccountCircle = class SwirlSymbolAccountCircle {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolAccountCircle, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolAccountCircle, selector: "swirl-symbol-account-circle", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolAccountCircle = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolAccountCircle);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolAccountCircle, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-account-circle',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolAlternateEmail = class SwirlSymbolAlternateEmail {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolAlternateEmail, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolAlternateEmail, selector: "swirl-symbol-alternate-email", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolAlternateEmail = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolAlternateEmail);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolAlternateEmail, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-alternate-email',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolAndroid = class SwirlSymbolAndroid {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolAndroid, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolAndroid, selector: "swirl-symbol-android", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolAndroid = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolAndroid);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolAndroid, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-android',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolAnnouncement = class SwirlSymbolAnnouncement {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolAnnouncement, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolAnnouncement, selector: "swirl-symbol-announcement", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolAnnouncement = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolAnnouncement);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolAnnouncement, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-announcement',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolBackup = class SwirlSymbolBackup {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolBackup, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolBackup, selector: "swirl-symbol-backup", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolBackup = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolBackup);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolBackup, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-backup',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolBeachAccess = class SwirlSymbolBeachAccess {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolBeachAccess, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolBeachAccess, selector: "swirl-symbol-beach-access", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolBeachAccess = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolBeachAccess);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolBeachAccess, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-beach-access',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolBookmark = class SwirlSymbolBookmark {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolBookmark, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolBookmark, selector: "swirl-symbol-bookmark", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolBookmark = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolBookmark);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolBookmark, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-bookmark',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolCloud = class SwirlSymbolCloud {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolCloud, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolCloud, selector: "swirl-symbol-cloud", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolCloud = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolCloud);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolCloud, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-cloud',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolCoronavirus = class SwirlSymbolCoronavirus {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolCoronavirus, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolCoronavirus, selector: "swirl-symbol-coronavirus", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolCoronavirus = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolCoronavirus);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolCoronavirus, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-coronavirus',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolDesktopWindows = class SwirlSymbolDesktopWindows {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolDesktopWindows, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolDesktopWindows, selector: "swirl-symbol-desktop-windows", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolDesktopWindows = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolDesktopWindows);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolDesktopWindows, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-desktop-windows',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolDirectionsCarFilled = class SwirlSymbolDirectionsCarFilled {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolDirectionsCarFilled, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolDirectionsCarFilled, selector: "swirl-symbol-directions-car-filled", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolDirectionsCarFilled = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolDirectionsCarFilled);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolDirectionsCarFilled, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-directions-car-filled',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolEditCalendar = class SwirlSymbolEditCalendar {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolEditCalendar, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolEditCalendar, selector: "swirl-symbol-edit-calendar", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolEditCalendar = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolEditCalendar);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolEditCalendar, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-edit-calendar',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolEmail = class SwirlSymbolEmail {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolEmail, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolEmail, selector: "swirl-symbol-email", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolEmail = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolEmail);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolEmail, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-email',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolEmojiFoodBeverage = class SwirlSymbolEmojiFoodBeverage {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolEmojiFoodBeverage, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolEmojiFoodBeverage, selector: "swirl-symbol-emoji-food-beverage", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolEmojiFoodBeverage = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolEmojiFoodBeverage);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolEmojiFoodBeverage, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-emoji-food-beverage',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolEventMenu = class SwirlSymbolEventMenu {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolEventMenu, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolEventMenu, selector: "swirl-symbol-event-menu", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolEventMenu = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolEventMenu);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolEventMenu, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-event-menu',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolFacebook = class SwirlSymbolFacebook {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolFacebook, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolFacebook, selector: "swirl-symbol-facebook", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolFacebook = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolFacebook);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolFacebook, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-facebook',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolFavorite = class SwirlSymbolFavorite {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolFavorite, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolFavorite, selector: "swirl-symbol-favorite", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolFavorite = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolFavorite);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolFavorite, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-favorite',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolFitnessCenter = class SwirlSymbolFitnessCenter {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolFitnessCenter, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolFitnessCenter, selector: "swirl-symbol-fitness-center", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolFitnessCenter = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolFitnessCenter);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolFitnessCenter, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-fitness-center',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolFlag = class SwirlSymbolFlag {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolFlag, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolFlag, selector: "swirl-symbol-flag", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolFlag = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolFlag);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolFlag, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-flag',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolFolder = class SwirlSymbolFolder {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolFolder, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolFolder, selector: "swirl-symbol-folder", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolFolder = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolFolder);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolFolder, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-folder',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolGlobe = class SwirlSymbolGlobe {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolGlobe, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolGlobe, selector: "swirl-symbol-globe", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolGlobe = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolGlobe);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolGlobe, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-globe',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolGroups = class SwirlSymbolGroups {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolGroups, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolGroups, selector: "swirl-symbol-groups", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolGroups = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolGroups);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolGroups, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-groups',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolHelp = class SwirlSymbolHelp {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolHelp, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolHelp, selector: "swirl-symbol-help", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolHelp = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolHelp);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolHelp, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-help',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolImage = class SwirlSymbolImage {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolImage, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolImage, selector: "swirl-symbol-image", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolImage = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolImage);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolImage, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-image',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolInfoMenu = class SwirlSymbolInfoMenu {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolInfoMenu, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolInfoMenu, selector: "swirl-symbol-info-menu", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolInfoMenu = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolInfoMenu);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolInfoMenu, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-info-menu',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolInstagram = class SwirlSymbolInstagram {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolInstagram, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolInstagram, selector: "swirl-symbol-instagram", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolInstagram = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolInstagram);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolInstagram, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-instagram',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolIos = class SwirlSymbolIos {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolIos, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolIos, selector: "swirl-symbol-ios", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolIos = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolIos);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolIos, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-ios',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolLanguage = class SwirlSymbolLanguage {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolLanguage, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolLanguage, selector: "swirl-symbol-language", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolLanguage = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolLanguage);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolLanguage, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-language',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolLeaderboard = class SwirlSymbolLeaderboard {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolLeaderboard, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolLeaderboard, selector: "swirl-symbol-leaderboard", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolLeaderboard = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolLeaderboard);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolLeaderboard, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-leaderboard',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolLightbulb = class SwirlSymbolLightbulb {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolLightbulb, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolLightbulb, selector: "swirl-symbol-lightbulb", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolLightbulb = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolLightbulb);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolLightbulb, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-lightbulb',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolLinkedin = class SwirlSymbolLinkedin {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolLinkedin, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolLinkedin, selector: "swirl-symbol-linkedin", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolLinkedin = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolLinkedin);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolLinkedin, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-linkedin',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolLocationOn = class SwirlSymbolLocationOn {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolLocationOn, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolLocationOn, selector: "swirl-symbol-location-on", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolLocationOn = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolLocationOn);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolLocationOn, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-location-on',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolLoyalty = class SwirlSymbolLoyalty {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolLoyalty, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolLoyalty, selector: "swirl-symbol-loyalty", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolLoyalty = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolLoyalty);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolLoyalty, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-loyalty',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolMapsHomeWork = class SwirlSymbolMapsHomeWork {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolMapsHomeWork, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolMapsHomeWork, selector: "swirl-symbol-maps-home-work", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolMapsHomeWork = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolMapsHomeWork);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolMapsHomeWork, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-maps-home-work',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolNotifications = class SwirlSymbolNotifications {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolNotifications, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolNotifications, selector: "swirl-symbol-notifications", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolNotifications = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolNotifications);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolNotifications, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-notifications',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolOpenInNew = class SwirlSymbolOpenInNew {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolOpenInNew, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolOpenInNew, selector: "swirl-symbol-open-in-new", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolOpenInNew = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolOpenInNew);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolOpenInNew, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-open-in-new',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolPedalBike = class SwirlSymbolPedalBike {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolPedalBike, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolPedalBike, selector: "swirl-symbol-pedal-bike", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolPedalBike = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolPedalBike);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolPedalBike, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-pedal-bike',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolPinterest = class SwirlSymbolPinterest {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolPinterest, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolPinterest, selector: "swirl-symbol-pinterest", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolPinterest = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolPinterest);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolPinterest, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-pinterest',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolPolicy = class SwirlSymbolPolicy {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolPolicy, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolPolicy, selector: "swirl-symbol-policy", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolPolicy = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolPolicy);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolPolicy, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-policy',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolPushPin = class SwirlSymbolPushPin {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolPushPin, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolPushPin, selector: "swirl-symbol-push-pin", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolPushPin = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolPushPin);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolPushPin, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-push-pin',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolRedeem = class SwirlSymbolRedeem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolRedeem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolRedeem, selector: "swirl-symbol-redeem", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolRedeem = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolRedeem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolRedeem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-redeem',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolReportProblem = class SwirlSymbolReportProblem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolReportProblem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolReportProblem, selector: "swirl-symbol-report-problem", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolReportProblem = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolReportProblem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolReportProblem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-report-problem',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolRestaurant = class SwirlSymbolRestaurant {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolRestaurant, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolRestaurant, selector: "swirl-symbol-restaurant", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolRestaurant = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolRestaurant);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolRestaurant, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-restaurant',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolRoadmap = class SwirlSymbolRoadmap {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolRoadmap, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolRoadmap, selector: "swirl-symbol-roadmap", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolRoadmap = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolRoadmap);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolRoadmap, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-roadmap',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolRoom = class SwirlSymbolRoom {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolRoom, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolRoom, selector: "swirl-symbol-room", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolRoom = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolRoom);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolRoom, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-room',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolSavings = class SwirlSymbolSavings {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolSavings, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolSavings, selector: "swirl-symbol-savings", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolSavings = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolSavings);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolSavings, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-savings',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolSettingsVoice = class SwirlSymbolSettingsVoice {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolSettingsVoice, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolSettingsVoice, selector: "swirl-symbol-settings-voice", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolSettingsVoice = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolSettingsVoice);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolSettingsVoice, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-settings-voice',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolShoppingCart = class SwirlSymbolShoppingCart {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolShoppingCart, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolShoppingCart, selector: "swirl-symbol-shopping-cart", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolShoppingCart = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolShoppingCart);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolShoppingCart, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-shopping-cart',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolSmartphone = class SwirlSymbolSmartphone {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolSmartphone, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolSmartphone, selector: "swirl-symbol-smartphone", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolSmartphone = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolSmartphone);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolSmartphone, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-smartphone',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolStar = class SwirlSymbolStar {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolStar, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolStar, selector: "swirl-symbol-star", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolStar = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolStar);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolStar, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-star',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolSupervisorAccount = class SwirlSymbolSupervisorAccount {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolSupervisorAccount, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolSupervisorAccount, selector: "swirl-symbol-supervisor-account", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolSupervisorAccount = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolSupervisorAccount);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolSupervisorAccount, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-supervisor-account',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolThumbsUpDown = class SwirlSymbolThumbsUpDown {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolThumbsUpDown, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolThumbsUpDown, selector: "swirl-symbol-thumbs-up-down", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolThumbsUpDown = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolThumbsUpDown);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolThumbsUpDown, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-thumbs-up-down',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolTwitter = class SwirlSymbolTwitter {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolTwitter, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolTwitter, selector: "swirl-symbol-twitter", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolTwitter = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolTwitter);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolTwitter, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-twitter',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolWbSunny = class SwirlSymbolWbSunny {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolWbSunny, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolWbSunny, selector: "swirl-symbol-wb-sunny", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolWbSunny = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolWbSunny);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolWbSunny, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-wb-sunny',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolWechat = class SwirlSymbolWechat {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolWechat, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolWechat, selector: "swirl-symbol-wechat", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolWechat = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolWechat);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolWechat, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-wechat',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolWeibo = class SwirlSymbolWeibo {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolWeibo, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolWeibo, selector: "swirl-symbol-weibo", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolWeibo = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolWeibo);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolWeibo, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-weibo',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolWork = class SwirlSymbolWork {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolWork, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolWork, selector: "swirl-symbol-work", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolWork = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolWork);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolWork, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-work',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolXing = class SwirlSymbolXing {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolXing, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolXing, selector: "swirl-symbol-xing", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolXing = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolXing);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolXing, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-xing',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlSymbolYoutube = class SwirlSymbolYoutube {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolYoutube, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlSymbolYoutube, selector: "swirl-symbol-youtube", inputs: { size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlSymbolYoutube = __decorate([
    ProxyCmp({
        inputs: ['size']
    })
], SwirlSymbolYoutube);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlSymbolYoutube, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-symbol-youtube',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['size'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTab = class SwirlTab {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTab, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTab, selector: "swirl-tab", inputs: { active: "active", icon: "icon", label: "label", padding: "padding", tabId: "tabId" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTab = __decorate([
    ProxyCmp({
        inputs: ['active', 'icon', 'label', 'padding', 'tabId']
    })
], SwirlTab);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTab, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-tab',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['active', 'icon', 'label', 'padding', 'tabId'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTabBar = class SwirlTabBar {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['activateNextTab', 'activatePreviousTab', 'activateTab']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTabBar, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTabBar, selector: "swirl-tab-bar", inputs: { disableTabSemantics: "disableTabSemantics", justify: "justify", label: "label", paddingBlockEnd: "paddingBlockEnd", paddingBlockStart: "paddingBlockStart", paddingInlineEnd: "paddingInlineEnd", paddingInlineStart: "paddingInlineStart", tabs: "tabs", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTabBar = __decorate([
    ProxyCmp({
        inputs: ['disableTabSemantics', 'justify', 'label', 'paddingBlockEnd', 'paddingBlockStart', 'paddingInlineEnd', 'paddingInlineStart', 'tabs', 'variant']
    })
], SwirlTabBar);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTabBar, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-tab-bar',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['disableTabSemantics', 'justify', 'label', 'paddingBlockEnd', 'paddingBlockStart', 'paddingInlineEnd', 'paddingInlineStart', 'tabs', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTable = class SwirlTable {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['dropRow']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTable, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTable, selector: "swirl-table", inputs: { caption: "caption", dragDropHandle: "dragDropHandle", dragDropInstructions: "dragDropInstructions", emptyStateLabel: "emptyStateLabel", enableDragDrop: "enableDragDrop", label: "label" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTable = __decorate([
    ProxyCmp({
        inputs: ['caption', 'dragDropHandle', 'dragDropInstructions', 'emptyStateLabel', 'enableDragDrop', 'label'],
        methods: ['rerender']
    })
], SwirlTable);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTable, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-table',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['caption', 'dragDropHandle', 'dragDropInstructions', 'emptyStateLabel', 'enableDragDrop', 'label'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTableCell = class SwirlTableCell {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTableCell, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTableCell, selector: "swirl-table-cell", ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTableCell = __decorate([
    ProxyCmp({})
], SwirlTableCell);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTableCell, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-table-cell',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: [],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTableColumn = class SwirlTableColumn {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTableColumn, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTableColumn, selector: "swirl-table-column", inputs: { maxWidth: "maxWidth", minWidth: "minWidth", sort: "sort", sortable: "sortable", sticky: "sticky", width: "width" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTableColumn = __decorate([
    ProxyCmp({
        inputs: ['maxWidth', 'minWidth', 'sort', 'sortable', 'sticky', 'width']
    })
], SwirlTableColumn);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTableColumn, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-table-column',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['maxWidth', 'minWidth', 'sort', 'sortable', 'sticky', 'width'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTableRow = class SwirlTableRow {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTableRow, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTableRow, selector: "swirl-table-row", inputs: { highlighted: "highlighted", index: "index" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTableRow = __decorate([
    ProxyCmp({
        inputs: ['highlighted', 'index']
    })
], SwirlTableRow);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTableRow, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-table-row',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['highlighted', 'index'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTableRowGroup = class SwirlTableRowGroup {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTableRowGroup, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTableRowGroup, selector: "swirl-table-row-group", inputs: { collapseButtonLabel: "collapseButtonLabel", collapsible: "collapsible", label: "label", tooltip: "tooltip" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTableRowGroup = __decorate([
    ProxyCmp({
        inputs: ['collapseButtonLabel', 'collapsible', 'label', 'tooltip']
    })
], SwirlTableRowGroup);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTableRowGroup, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-table-row-group',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['collapseButtonLabel', 'collapsible', 'label', 'tooltip'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTabs = class SwirlTabs {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['tabActivated']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTabs, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTabs, selector: "swirl-tabs", inputs: { initialTab: "initialTab", justifyTabBar: "justifyTabBar", label: "label", tabBarPaddingBlockEnd: "tabBarPaddingBlockEnd", tabBarPaddingBlockStart: "tabBarPaddingBlockStart", tabBarPaddingInlineEnd: "tabBarPaddingInlineEnd", tabBarPaddingInlineStart: "tabBarPaddingInlineStart", tabBarVariant: "tabBarVariant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTabs = __decorate([
    ProxyCmp({
        inputs: ['initialTab', 'justifyTabBar', 'label', 'tabBarPaddingBlockEnd', 'tabBarPaddingBlockStart', 'tabBarPaddingInlineEnd', 'tabBarPaddingInlineStart', 'tabBarVariant'],
        methods: ['activateTab']
    })
], SwirlTabs);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTabs, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-tabs',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['initialTab', 'justifyTabBar', 'label', 'tabBarPaddingBlockEnd', 'tabBarPaddingBlockStart', 'tabBarPaddingInlineEnd', 'tabBarPaddingInlineStart', 'tabBarVariant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTag = class SwirlTag {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['remove']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTag, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTag, selector: "swirl-tag", inputs: { bordered: "bordered", icon: "icon", iconPosition: "iconPosition", intent: "intent", label: "label", removable: "removable", removalButtonLabel: "removalButtonLabel", size: "size", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTag = __decorate([
    ProxyCmp({
        inputs: ['bordered', 'icon', 'iconPosition', 'intent', 'label', 'removable', 'removalButtonLabel', 'size', 'variant']
    })
], SwirlTag);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTag, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-tag',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['bordered', 'icon', 'iconPosition', 'intent', 'label', 'removable', 'removalButtonLabel', 'size', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlText = class SwirlText {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlText, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlText, selector: "swirl-text", inputs: { align: "align", as: "as", balance: "balance", color: "color", fontFamily: "fontFamily", fontStyle: "fontStyle", lines: "lines", responsive: "responsive", size: "size", truncate: "truncate", truncateDirection: "truncateDirection", weight: "weight", whiteSpace: "whiteSpace" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlText = __decorate([
    ProxyCmp({
        inputs: ['align', 'as', 'balance', 'color', 'fontFamily', 'fontStyle', 'lines', 'responsive', 'size', 'truncate', 'truncateDirection', 'weight', 'whiteSpace']
    })
], SwirlText);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlText, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-text',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['align', 'as', 'balance', 'color', 'fontFamily', 'fontStyle', 'lines', 'responsive', 'size', 'truncate', 'truncateDirection', 'weight', 'whiteSpace'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTextInput = class SwirlTextInput {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['inputBlur', 'inputFocus', 'valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTextInput, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTextInput, selector: "swirl-text-input", inputs: { autoComplete: "autoComplete", autoFocus: "autoFocus", autoGrow: "autoGrow", autoSelect: "autoSelect", characterCounterLabel: "characterCounterLabel", clearButtonLabel: "clearButtonLabel", clearable: "clearable", disableDynamicWidth: "disableDynamicWidth", disabled: "disabled", fontSize: "fontSize", inline: "inline", inputName: "inputName", invalid: "invalid", max: "max", maxLength: "maxLength", min: "min", mode: "mode", passwordToggleLabel: "passwordToggleLabel", placeholder: "placeholder", prefixLabel: "prefixLabel", required: "required", rows: "rows", showCharacterCounter: "showCharacterCounter", spellCheck: "spellCheck", step: "step", suffixLabel: "suffixLabel", swirlAriaAutocomplete: "swirlAriaAutocomplete", swirlAriaControls: "swirlAriaControls", swirlAriaDescribedby: "swirlAriaDescribedby", swirlAriaExpanded: "swirlAriaExpanded", swirlRole: "swirlRole", type: "type", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTextInput = __decorate([
    ProxyCmp({
        inputs: ['autoComplete', 'autoFocus', 'autoGrow', 'autoSelect', 'characterCounterLabel', 'clearButtonLabel', 'clearable', 'disableDynamicWidth', 'disabled', 'fontSize', 'inline', 'inputName', 'invalid', 'max', 'maxLength', 'min', 'mode', 'passwordToggleLabel', 'placeholder', 'prefixLabel', 'required', 'rows', 'showCharacterCounter', 'spellCheck', 'step', 'suffixLabel', 'swirlAriaAutocomplete', 'swirlAriaControls', 'swirlAriaDescribedby', 'swirlAriaExpanded', 'swirlRole', 'type', 'value'],
        methods: ['blurInput', 'focusInput']
    })
], SwirlTextInput);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTextInput, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-text-input',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['autoComplete', 'autoFocus', 'autoGrow', 'autoSelect', 'characterCounterLabel', 'clearButtonLabel', 'clearable', 'disableDynamicWidth', 'disabled', 'fontSize', 'inline', 'inputName', 'invalid', 'max', 'maxLength', 'min', 'mode', 'passwordToggleLabel', 'placeholder', 'prefixLabel', 'required', 'rows', 'showCharacterCounter', 'spellCheck', 'step', 'suffixLabel', 'swirlAriaAutocomplete', 'swirlAriaControls', 'swirlAriaDescribedby', 'swirlAriaExpanded', 'swirlRole', 'type', 'value'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlThemeProvider = class SwirlThemeProvider {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['appThemeUpdated', 'themeChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlThemeProvider, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlThemeProvider, selector: "swirl-theme-provider", inputs: { config: "config" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlThemeProvider = __decorate([
    ProxyCmp({
        inputs: ['config'],
        methods: ['getActiveOSTheme', 'getPreferredOSTheme', 'setPreferredOSTheme', 'resetPreferredOSTheme']
    })
], SwirlThemeProvider);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlThemeProvider, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-theme-provider',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['config'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlThumbnail = class SwirlThumbnail {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['edit', 'remove', 'thumbnailClick']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlThumbnail, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlThumbnail, selector: "swirl-thumbnail", inputs: { alt: "alt", editButtonIcon: "editButtonIcon", editButtonLabel: "editButtonLabel", format: "format", interactive: "interactive", progress: "progress", progressLabel: "progressLabel", removeButtonLabel: "removeButtonLabel", showEditButton: "showEditButton", showRemoveButton: "showRemoveButton", size: "size", src: "src", timestamp: "timestamp" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlThumbnail = __decorate([
    ProxyCmp({
        inputs: ['alt', 'editButtonIcon', 'editButtonLabel', 'format', 'interactive', 'progress', 'progressLabel', 'removeButtonLabel', 'showEditButton', 'showRemoveButton', 'size', 'src', 'timestamp']
    })
], SwirlThumbnail);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlThumbnail, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-thumbnail',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['alt', 'editButtonIcon', 'editButtonLabel', 'format', 'interactive', 'progress', 'progressLabel', 'removeButtonLabel', 'showEditButton', 'showRemoveButton', 'size', 'src', 'timestamp'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTimeInput = class SwirlTimeInput {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['inputBlur', 'inputFocus', 'valueChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTimeInput, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTimeInput, selector: "swirl-time-input", inputs: { autoFocus: "autoFocus", autoSelect: "autoSelect", disabled: "disabled", format: "format", inline: "inline", invalid: "invalid", placeholder: "placeholder", required: "required", swirlAriaDescribedby: "swirlAriaDescribedby", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTimeInput = __decorate([
    ProxyCmp({
        inputs: ['autoFocus', 'autoSelect', 'disabled', 'format', 'inline', 'invalid', 'placeholder', 'required', 'swirlAriaDescribedby', 'value']
    })
], SwirlTimeInput);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTimeInput, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-time-input',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['autoFocus', 'autoSelect', 'disabled', 'format', 'inline', 'invalid', 'placeholder', 'required', 'swirlAriaDescribedby', 'value'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlToast = class SwirlToast {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['dismiss']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlToast, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlToast, selector: "swirl-toast", inputs: { accessibleDismissLabel: "accessibleDismissLabel", content: "content", dismissLabel: "dismissLabel", duration: "duration", icon: "icon", intent: "intent", toastId: "toastId" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlToast = __decorate([
    ProxyCmp({
        inputs: ['accessibleDismissLabel', 'content', 'dismissLabel', 'duration', 'icon', 'intent', 'toastId']
    })
], SwirlToast);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlToast, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-toast',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['accessibleDismissLabel', 'content', 'dismissLabel', 'duration', 'icon', 'intent', 'toastId'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlToastProvider = class SwirlToastProvider {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlToastProvider, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlToastProvider, selector: "swirl-toast-provider", inputs: { globalDuration: "globalDuration" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlToastProvider = __decorate([
    ProxyCmp({
        inputs: ['globalDuration'],
        methods: ['clearAll', 'dismiss', 'toast']
    })
], SwirlToastProvider);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlToastProvider, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-toast-provider',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['globalDuration'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlToggleButton = class SwirlToggleButton {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlToggleButton, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlToggleButton, selector: "swirl-toggle-button", inputs: { icon: "icon", identifier: "identifier", isPressed: "isPressed", label: "label" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlToggleButton = __decorate([
    ProxyCmp({
        inputs: ['icon', 'identifier', 'isPressed', 'label']
    })
], SwirlToggleButton);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlToggleButton, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-toggle-button',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['icon', 'identifier', 'isPressed', 'label'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlToggleGroup = class SwirlToggleGroup {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['selectedToggleChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlToggleGroup, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlToggleGroup, selector: "swirl-toggle-group", inputs: { elevated: "elevated", selectedToggleId: "selectedToggleId", swirlAriaLabel: "swirlAriaLabel", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlToggleGroup = __decorate([
    ProxyCmp({
        inputs: ['elevated', 'selectedToggleId', 'swirlAriaLabel', 'variant']
    })
], SwirlToggleGroup);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlToggleGroup, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-toggle-group',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['elevated', 'selectedToggleId', 'swirlAriaLabel', 'variant'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlToolbar = class SwirlToolbar {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlToolbar, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlToolbar, selector: "swirl-toolbar", inputs: { label: "label", orientation: "orientation" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlToolbar = __decorate([
    ProxyCmp({
        inputs: ['label', 'orientation']
    })
], SwirlToolbar);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlToolbar, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-toolbar',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['label', 'orientation'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTooltip = class SwirlTooltip {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTooltip, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTooltip, selector: "swirl-tooltip", inputs: { active: "active", content: "content", delay: "delay", position: "position", positioning: "positioning" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTooltip = __decorate([
    ProxyCmp({
        inputs: ['active', 'content', 'delay', 'position', 'positioning']
    })
], SwirlTooltip);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTooltip, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-tooltip',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['active', 'content', 'delay', 'position', 'positioning'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTreeNavigation = class SwirlTreeNavigation {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTreeNavigation, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTreeNavigation, selector: "swirl-tree-navigation", inputs: { label: "label" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTreeNavigation = __decorate([
    ProxyCmp({
        inputs: ['label']
    })
], SwirlTreeNavigation);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTreeNavigation, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-tree-navigation',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['label'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTreeNavigationItem = class SwirlTreeNavigationItem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['expansionChange']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTreeNavigationItem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTreeNavigationItem, selector: "swirl-tree-navigation-item", inputs: { active: "active", expandable: "expandable", external: "external", href: "href", icon: "icon", label: "label", level: "level", navigationItemId: "navigationItemId", target: "target" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTreeNavigationItem = __decorate([
    ProxyCmp({
        inputs: ['active', 'expandable', 'external', 'href', 'icon', 'label', 'level', 'navigationItemId', 'target'],
        methods: ['expand', 'collapse']
    })
], SwirlTreeNavigationItem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTreeNavigationItem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-tree-navigation-item',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['active', 'expandable', 'external', 'href', 'icon', 'label', 'level', 'navigationItemId', 'target'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTreeView = class SwirlTreeView {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['dropItem', 'itemExpansionChanged']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTreeView, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTreeView, selector: "swirl-tree-view", inputs: { canDrop: "canDrop", dragDropInstructions: "dragDropInstructions", dragDropItemSelector: "dragDropItemSelector", enableDragDrop: "enableDragDrop", initiallyExpandedItemIds: "initiallyExpandedItemIds", label: "label", semantics: "semantics" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTreeView = __decorate([
    ProxyCmp({
        inputs: ['canDrop', 'dragDropInstructions', 'dragDropItemSelector', 'enableDragDrop', 'initiallyExpandedItemIds', 'label', 'semantics'],
        methods: ['expandItems']
    })
], SwirlTreeView);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTreeView, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-tree-view',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['canDrop', 'dragDropInstructions', 'dragDropItemSelector', 'enableDragDrop', 'initiallyExpandedItemIds', 'label', 'semantics'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlTreeViewItem = class SwirlTreeViewItem {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['dropTreeViewItem', 'expandedChange', 'itemSelected', 'startKeyboardMove', 'endKeyboardMove', 'keyboardMove']);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTreeViewItem, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlTreeViewItem, selector: "swirl-tree-view-item", inputs: { active: "active", disableDrag: "disableDrag", expandable: "expandable", href: "href", icon: "icon", iconColor: "iconColor", itemId: "itemId", label: "label" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlTreeViewItem = __decorate([
    ProxyCmp({
        inputs: ['active', 'disableDrag', 'expandable', 'href', 'icon', 'iconColor', 'itemId', 'label'],
        methods: ['expand', 'collapse', 'select', 'unselect']
    })
], SwirlTreeViewItem);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlTreeViewItem, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-tree-view-item',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['active', 'disableDrag', 'expandable', 'href', 'icon', 'iconColor', 'itemId', 'label'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlVideoThumbnail = class SwirlVideoThumbnail {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlVideoThumbnail, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlVideoThumbnail, selector: "swirl-video-thumbnail", inputs: { duration: "duration", durationLabel: "durationLabel", label: "label", src: "src" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlVideoThumbnail = __decorate([
    ProxyCmp({
        inputs: ['duration', 'durationLabel', 'label', 'src']
    })
], SwirlVideoThumbnail);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlVideoThumbnail, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-video-thumbnail',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['duration', 'durationLabel', 'label', 'src'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });
let SwirlVisuallyHidden = class SwirlVisuallyHidden {
    z;
    el;
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlVisuallyHidden, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SwirlVisuallyHidden, selector: "swirl-visually-hidden", ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
};
SwirlVisuallyHidden = __decorate([
    ProxyCmp({})
], SwirlVisuallyHidden);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlVisuallyHidden, decorators: [{
            type: Component,
            args: [{
                    selector: 'swirl-visually-hidden',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: [],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });

class ValueAccessor {
    el;
    onChange = () => { };
    onTouched = () => { };
    lastValue;
    constructor(el) {
        this.el = el;
    }
    writeValue(value) {
        this.el.nativeElement.value = this.lastValue = value == null ? '' : value;
    }
    handleChangeEvent(value) {
        if (value !== this.lastValue) {
            this.lastValue = value;
            this.onChange(value);
        }
    }
    _handleBlurEvent() {
        this.onTouched();
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    setDisabledState(isDisabled) {
        this.el.nativeElement.disabled = isDisabled;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ValueAccessor, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
    static ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: ValueAccessor, host: { listeners: { "focusout": "_handleBlurEvent()" } }, ngImport: i0 });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ValueAccessor, decorators: [{
            type: Directive,
            args: [{}]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { _handleBlurEvent: [{
                type: HostListener,
                args: ['focusout']
            }] } });

class BooleanValueAccessor extends ValueAccessor {
    constructor(el) {
        super(el);
    }
    writeValue(value) {
        this.el.nativeElement.checked = this.lastValue = value == null ? false : value;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: BooleanValueAccessor, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
    static ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: BooleanValueAccessor, selector: "swirl-checkbox, swirl-resource-list-item, swirl-switch", host: { listeners: { "valueChange": "handleChangeEvent($event.target.checked)" } }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                useExisting: BooleanValueAccessor,
                multi: true
            }
        ], usesInheritance: true, ngImport: i0 });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: BooleanValueAccessor, decorators: [{
            type: Directive,
            args: [{
                    /* tslint:disable-next-line:directive-selector */
                    selector: 'swirl-checkbox, swirl-resource-list-item, swirl-switch',
                    host: {
                        '(valueChange)': 'handleChangeEvent($event.target.checked)'
                    },
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: BooleanValueAccessor,
                            multi: true
                        }
                    ]
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; } });

class SelectValueAccessor extends ValueAccessor {
    constructor(el) {
        super(el);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SelectValueAccessor, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
    static ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: SelectValueAccessor, selector: "swirl-autocomplete[multi-select], swirl-autocomplete[multiSelect], swirl-option-list, swirl-select", host: { listeners: { "valueChange": "handleChangeEvent($event.target.value)" } }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                useExisting: SelectValueAccessor,
                multi: true
            }
        ], usesInheritance: true, ngImport: i0 });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SelectValueAccessor, decorators: [{
            type: Directive,
            args: [{
                    /* tslint:disable-next-line:directive-selector */
                    selector: 'swirl-autocomplete[multi-select], swirl-autocomplete[multiSelect], swirl-option-list, swirl-select',
                    host: {
                        '(valueChange)': 'handleChangeEvent($event.target.value)'
                    },
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: SelectValueAccessor,
                            multi: true
                        }
                    ]
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; } });

class TextValueAccessor extends ValueAccessor {
    constructor(el) {
        super(el);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TextValueAccessor, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
    static ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: TextValueAccessor, selector: "swirl-autocomplete:not([multi-select]):not([multiSelect]), swirl-color-input, swirl-date-input, swirl-radio-group, swirl-search, swirl-text-input, swirl-time-input", host: { listeners: { "valueChange": "handleChangeEvent($event.target.value)" } }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                useExisting: TextValueAccessor,
                multi: true
            }
        ], usesInheritance: true, ngImport: i0 });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TextValueAccessor, decorators: [{
            type: Directive,
            args: [{
                    /* tslint:disable-next-line:directive-selector */
                    selector: 'swirl-autocomplete:not([multi-select]):not([multiSelect]), swirl-color-input, swirl-date-input, swirl-radio-group, swirl-search, swirl-text-input, swirl-time-input',
                    host: {
                        '(valueChange)': 'handleChangeEvent($event.target.value)'
                    },
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: TextValueAccessor,
                            multi: true
                        }
                    ]
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; } });

const DIRECTIVES = [
    FileManager,
    SwirlAccordion,
    SwirlAccordionItem,
    SwirlActionList,
    SwirlActionListItem,
    SwirlActionListSection,
    SwirlAppBar,
    SwirlAppIcon,
    SwirlAppLayout,
    SwirlAutocomplete,
    SwirlAvatar,
    SwirlAvatarGroup,
    SwirlBadge,
    SwirlBanner,
    SwirlBox,
    SwirlButton,
    SwirlButtonGroup,
    SwirlCard,
    SwirlCarousel,
    SwirlCarouselSlide,
    SwirlCheckbox,
    SwirlChip,
    SwirlColorInput,
    SwirlColumns,
    SwirlConsoleLayout,
    SwirlDateInput,
    SwirlDatePicker,
    SwirlDescriptionList,
    SwirlDescriptionListItem,
    SwirlDialog,
    SwirlEmoji,
    SwirlEmojiClap,
    SwirlEmojiHappy,
    SwirlEmojiIdea,
    SwirlEmojiLove,
    SwirlEmojiSad,
    SwirlEmojiThumbsUp,
    SwirlEmptyState,
    SwirlFileChip,
    SwirlFileUploader,
    SwirlFileViewer,
    SwirlFileViewerAudio,
    SwirlFileViewerCsv,
    SwirlFileViewerFallback,
    SwirlFileViewerImage,
    SwirlFileViewerPdf,
    SwirlFileViewerText,
    SwirlFileViewerVideo,
    SwirlFormControl,
    SwirlFormGroup,
    SwirlHeading,
    SwirlIcon,
    SwirlIconAdd,
    SwirlIconAddModerator,
    SwirlIconAddPhoto,
    SwirlIconAddReaction,
    SwirlIconAdminPanelSettings,
    SwirlIconAi,
    SwirlIconAiFilled,
    SwirlIconApps,
    SwirlIconArrowBack,
    SwirlIconArrowDownward,
    SwirlIconArrowForward,
    SwirlIconArrowLeft,
    SwirlIconArrowRight,
    SwirlIconArrowRightSmall,
    SwirlIconArrowUpward,
    SwirlIconAspectRatio,
    SwirlIconAttachment,
    SwirlIconAudioFile,
    SwirlIconBarChart,
    SwirlIconBeachAccess,
    SwirlIconBeachAccessFilled,
    SwirlIconBlock,
    SwirlIconBookmark,
    SwirlIconBookmarkFilled,
    SwirlIconCalendarAddOnFilled,
    SwirlIconCalendarRespond,
    SwirlIconCalendarToday,
    SwirlIconCall,
    SwirlIconCallEnd,
    SwirlIconCancel,
    SwirlIconCancelFilled,
    SwirlIconChatBubble,
    SwirlIconChats,
    SwirlIconChatsFilled,
    SwirlIconCheck,
    SwirlIconCheckCircle,
    SwirlIconCheckCircleFilled,
    SwirlIconCheckSmall,
    SwirlIconCheckStrong,
    SwirlIconChevronLeft,
    SwirlIconChevronRight,
    SwirlIconClose,
    SwirlIconCloseFullscreen,
    SwirlIconCloseSmall,
    SwirlIconCloudUpload,
    SwirlIconColumn,
    SwirlIconComment,
    SwirlIconContrast,
    SwirlIconCopy,
    SwirlIconCrop,
    SwirlIconDarkMode,
    SwirlIconDateRange,
    SwirlIconDelete,
    SwirlIconDeployedCode,
    SwirlIconDescription,
    SwirlIconDesktop,
    SwirlIconDirectory,
    SwirlIconDirectoryFilled,
    SwirlIconDiscover,
    SwirlIconDockLeft,
    SwirlIconDockLeftCollapse,
    SwirlIconDockLeftExpand,
    SwirlIconDoorOpen,
    SwirlIconDot,
    SwirlIconDoubleArrowLeft,
    SwirlIconDoubleArrowRight,
    SwirlIconDownload,
    SwirlIconDragHandle,
    SwirlIconEdit,
    SwirlIconEditNote,
    SwirlIconEmojiMood,
    SwirlIconEmojiSatisfied,
    SwirlIconError,
    SwirlIconExpandLess,
    SwirlIconExpandMore,
    SwirlIconExperiment,
    SwirlIconFile,
    SwirlIconFileCopy,
    SwirlIconFilter,
    SwirlIconFolder,
    SwirlIconFolderShared,
    SwirlIconFormatHOne,
    SwirlIconFormatListBulleted,
    SwirlIconFullscreen,
    SwirlIconFullscreenExit,
    SwirlIconGif,
    SwirlIconGroupAdd,
    SwirlIconGroupAssign,
    SwirlIconGroups,
    SwirlIconGroupsFilled,
    SwirlIconHamburgerMenu,
    SwirlIconHealthAndSafety,
    SwirlIconHelp,
    SwirlIconHelpFilled,
    SwirlIconHighlight,
    SwirlIconHistory,
    SwirlIconHome,
    SwirlIconHrResting,
    SwirlIconImage,
    SwirlIconImproveText,
    SwirlIconInfo,
    SwirlIconInsertBelow,
    SwirlIconInsertChart,
    SwirlIconInsertOnTop,
    SwirlIconInventory,
    SwirlIconInventoryOff,
    SwirlIconIphone,
    SwirlIconKey,
    SwirlIconKeyboard,
    SwirlIconKeyboardHide,
    SwirlIconLightMode,
    SwirlIconLike,
    SwirlIconLink,
    SwirlIconLive,
    SwirlIconLoad,
    SwirlIconLocationOn,
    SwirlIconLock,
    SwirlIconLockOpen,
    SwirlIconLockPerson,
    SwirlIconLogin,
    SwirlIconLogout,
    SwirlIconLongText,
    SwirlIconMail,
    SwirlIconManageAccounts,
    SwirlIconMarkChatRead,
    SwirlIconMarkChatUnread,
    SwirlIconMention,
    SwirlIconMenu,
    SwirlIconMenuBook,
    SwirlIconMenuBookFilled,
    SwirlIconMenuFilled,
    SwirlIconMessage,
    SwirlIconMic,
    SwirlIconMicOff,
    SwirlIconMoreHorizontal,
    SwirlIconMoreVertikal,
    SwirlIconNews,
    SwirlIconNewsFilled,
    SwirlIconNewsOff,
    SwirlIconNextPlan,
    SwirlIconNotifications,
    SwirlIconNotificationsActive,
    SwirlIconNotificationsOff,
    SwirlIconOpenInFull,
    SwirlIconOpenInNew,
    SwirlIconPause,
    SwirlIconPauseCircle,
    SwirlIconPeopleAlt,
    SwirlIconPerson,
    SwirlIconPersonOff,
    SwirlIconPhone,
    SwirlIconPhotoCamera,
    SwirlIconPictureAsPdf,
    SwirlIconPictureInPicture,
    SwirlIconPin,
    SwirlIconPinOff,
    SwirlIconPlace,
    SwirlIconPlayArrow,
    SwirlIconPoll,
    SwirlIconPostApproval,
    SwirlIconPresent,
    SwirlIconPreview,
    SwirlIconPrint,
    SwirlIconPublic,
    SwirlIconPublicOff,
    SwirlIconPublishedWithChanges,
    SwirlIconRatioFourToThree,
    SwirlIconRatioFreeform,
    SwirlIconRatioSixteenToNine,
    SwirlIconRatioSquare,
    SwirlIconRatioThreeToFour,
    SwirlIconRatioThreeToTwo,
    SwirlIconRecieved,
    SwirlIconRemove,
    SwirlIconRemoveCircle,
    SwirlIconRemoveModerator,
    SwirlIconReply,
    SwirlIconReport,
    SwirlIconRoadmap,
    SwirlIconRotateLeft,
    SwirlIconRotateRight,
    SwirlIconScreenshare,
    SwirlIconScreenshareOff,
    SwirlIconSearch,
    SwirlIconSearchStrong,
    SwirlIconSecure,
    SwirlIconSend,
    SwirlIconSettings,
    SwirlIconShortText,
    SwirlIconSimplify,
    SwirlIconSpellcheck,
    SwirlIconStars,
    SwirlIconStickyNote,
    SwirlIconStop,
    SwirlIconStopCircle,
    SwirlIconSunny,
    SwirlIconSync,
    SwirlIconTasks,
    SwirlIconTasksFilled,
    SwirlIconTerminal,
    SwirlIconTime,
    SwirlIconTimeFilled,
    SwirlIconToday,
    SwirlIconTodayFilled,
    SwirlIconTranslate,
    SwirlIconTreeStructure,
    SwirlIconUndo,
    SwirlIconUnlockPerson,
    SwirlIconUpload,
    SwirlIconUserAdd,
    SwirlIconUserAssign,
    SwirlIconVideoCamera,
    SwirlIconVideoCameraOff,
    SwirlIconVideoLibrary,
    SwirlIconVideoPlayer,
    SwirlIconViewAgenda,
    SwirlIconVisibility,
    SwirlIconVisibilityOff,
    SwirlIconVoice,
    SwirlIconVolumeUp,
    SwirlIconWarning,
    SwirlIconWebAsset,
    SwirlIconWebAssetOff,
    SwirlIconWork,
    SwirlImageGrid,
    SwirlImageGridItem,
    SwirlInlineError,
    SwirlInlineNotification,
    SwirlInlineStatus,
    SwirlLightbox,
    SwirlLink,
    SwirlList,
    SwirlMenu,
    SwirlMenuItem,
    SwirlModal,
    SwirlOptionList,
    SwirlOptionListItem,
    SwirlOptionListSection,
    SwirlPagination,
    SwirlPdfReader,
    SwirlPopover,
    SwirlPopoverTrigger,
    SwirlProgressIndicator,
    SwirlRadio,
    SwirlRadioGroup,
    SwirlResourceList,
    SwirlResourceListFileItem,
    SwirlResourceListItem,
    SwirlResourceListSection,
    SwirlSearch,
    SwirlSelect,
    SwirlSeparator,
    SwirlShellLayout,
    SwirlShellNavigationItem,
    SwirlSkeletonBox,
    SwirlSkeletonText,
    SwirlSpinner,
    SwirlStack,
    SwirlStatusIndicator,
    SwirlSwitch,
    SwirlSymbol,
    SwirlSymbolAccountCircle,
    SwirlSymbolAlternateEmail,
    SwirlSymbolAndroid,
    SwirlSymbolAnnouncement,
    SwirlSymbolBackup,
    SwirlSymbolBeachAccess,
    SwirlSymbolBookmark,
    SwirlSymbolCloud,
    SwirlSymbolCoronavirus,
    SwirlSymbolDesktopWindows,
    SwirlSymbolDirectionsCarFilled,
    SwirlSymbolEditCalendar,
    SwirlSymbolEmail,
    SwirlSymbolEmojiFoodBeverage,
    SwirlSymbolEventMenu,
    SwirlSymbolFacebook,
    SwirlSymbolFavorite,
    SwirlSymbolFitnessCenter,
    SwirlSymbolFlag,
    SwirlSymbolFolder,
    SwirlSymbolGlobe,
    SwirlSymbolGroups,
    SwirlSymbolHelp,
    SwirlSymbolImage,
    SwirlSymbolInfoMenu,
    SwirlSymbolInstagram,
    SwirlSymbolIos,
    SwirlSymbolLanguage,
    SwirlSymbolLeaderboard,
    SwirlSymbolLightbulb,
    SwirlSymbolLinkedin,
    SwirlSymbolLocationOn,
    SwirlSymbolLoyalty,
    SwirlSymbolMapsHomeWork,
    SwirlSymbolNotifications,
    SwirlSymbolOpenInNew,
    SwirlSymbolPedalBike,
    SwirlSymbolPinterest,
    SwirlSymbolPolicy,
    SwirlSymbolPushPin,
    SwirlSymbolRedeem,
    SwirlSymbolReportProblem,
    SwirlSymbolRestaurant,
    SwirlSymbolRoadmap,
    SwirlSymbolRoom,
    SwirlSymbolSavings,
    SwirlSymbolSettingsVoice,
    SwirlSymbolShoppingCart,
    SwirlSymbolSmartphone,
    SwirlSymbolStar,
    SwirlSymbolSupervisorAccount,
    SwirlSymbolThumbsUpDown,
    SwirlSymbolTwitter,
    SwirlSymbolWbSunny,
    SwirlSymbolWechat,
    SwirlSymbolWeibo,
    SwirlSymbolWork,
    SwirlSymbolXing,
    SwirlSymbolYoutube,
    SwirlTab,
    SwirlTabBar,
    SwirlTable,
    SwirlTableCell,
    SwirlTableColumn,
    SwirlTableRow,
    SwirlTableRowGroup,
    SwirlTabs,
    SwirlTag,
    SwirlText,
    SwirlTextInput,
    SwirlThemeProvider,
    SwirlThumbnail,
    SwirlTimeInput,
    SwirlToast,
    SwirlToastProvider,
    SwirlToggleButton,
    SwirlToggleGroup,
    SwirlToolbar,
    SwirlTooltip,
    SwirlTreeNavigation,
    SwirlTreeNavigationItem,
    SwirlTreeView,
    SwirlTreeViewItem,
    SwirlVideoThumbnail,
    SwirlVisuallyHidden
];

class SwirlComponentsModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlComponentsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: SwirlComponentsModule, declarations: [FileManager, SwirlAccordion, SwirlAccordionItem, SwirlActionList, SwirlActionListItem, SwirlActionListSection, SwirlAppBar, SwirlAppIcon, SwirlAppLayout, SwirlAutocomplete, SwirlAvatar, SwirlAvatarGroup, SwirlBadge, SwirlBanner, SwirlBox, SwirlButton, SwirlButtonGroup, SwirlCard, SwirlCarousel, SwirlCarouselSlide, SwirlCheckbox, SwirlChip, SwirlColorInput, SwirlColumns, SwirlConsoleLayout, SwirlDateInput, SwirlDatePicker, SwirlDescriptionList, SwirlDescriptionListItem, SwirlDialog, SwirlEmoji, SwirlEmojiClap, SwirlEmojiHappy, SwirlEmojiIdea, SwirlEmojiLove, SwirlEmojiSad, SwirlEmojiThumbsUp, SwirlEmptyState, SwirlFileChip, SwirlFileUploader, SwirlFileViewer, SwirlFileViewerAudio, SwirlFileViewerCsv, SwirlFileViewerFallback, SwirlFileViewerImage, SwirlFileViewerPdf, SwirlFileViewerText, SwirlFileViewerVideo, SwirlFormControl, SwirlFormGroup, SwirlHeading, SwirlIcon, SwirlIconAdd, SwirlIconAddModerator, SwirlIconAddPhoto, SwirlIconAddReaction, SwirlIconAdminPanelSettings, SwirlIconAi, SwirlIconAiFilled, SwirlIconApps, SwirlIconArrowBack, SwirlIconArrowDownward, SwirlIconArrowForward, SwirlIconArrowLeft, SwirlIconArrowRight, SwirlIconArrowRightSmall, SwirlIconArrowUpward, SwirlIconAspectRatio, SwirlIconAttachment, SwirlIconAudioFile, SwirlIconBarChart, SwirlIconBeachAccess, SwirlIconBeachAccessFilled, SwirlIconBlock, SwirlIconBookmark, SwirlIconBookmarkFilled, SwirlIconCalendarAddOnFilled, SwirlIconCalendarRespond, SwirlIconCalendarToday, SwirlIconCall, SwirlIconCallEnd, SwirlIconCancel, SwirlIconCancelFilled, SwirlIconChatBubble, SwirlIconChats, SwirlIconChatsFilled, SwirlIconCheck, SwirlIconCheckCircle, SwirlIconCheckCircleFilled, SwirlIconCheckSmall, SwirlIconCheckStrong, SwirlIconChevronLeft, SwirlIconChevronRight, SwirlIconClose, SwirlIconCloseFullscreen, SwirlIconCloseSmall, SwirlIconCloudUpload, SwirlIconColumn, SwirlIconComment, SwirlIconContrast, SwirlIconCopy, SwirlIconCrop, SwirlIconDarkMode, SwirlIconDateRange, SwirlIconDelete, SwirlIconDeployedCode, SwirlIconDescription, SwirlIconDesktop, SwirlIconDirectory, SwirlIconDirectoryFilled, SwirlIconDiscover, SwirlIconDockLeft, SwirlIconDockLeftCollapse, SwirlIconDockLeftExpand, SwirlIconDoorOpen, SwirlIconDot, SwirlIconDoubleArrowLeft, SwirlIconDoubleArrowRight, SwirlIconDownload, SwirlIconDragHandle, SwirlIconEdit, SwirlIconEditNote, SwirlIconEmojiMood, SwirlIconEmojiSatisfied, SwirlIconError, SwirlIconExpandLess, SwirlIconExpandMore, SwirlIconExperiment, SwirlIconFile, SwirlIconFileCopy, SwirlIconFilter, SwirlIconFolder, SwirlIconFolderShared, SwirlIconFormatHOne, SwirlIconFormatListBulleted, SwirlIconFullscreen, SwirlIconFullscreenExit, SwirlIconGif, SwirlIconGroupAdd, SwirlIconGroupAssign, SwirlIconGroups, SwirlIconGroupsFilled, SwirlIconHamburgerMenu, SwirlIconHealthAndSafety, SwirlIconHelp, SwirlIconHelpFilled, SwirlIconHighlight, SwirlIconHistory, SwirlIconHome, SwirlIconHrResting, SwirlIconImage, SwirlIconImproveText, SwirlIconInfo, SwirlIconInsertBelow, SwirlIconInsertChart, SwirlIconInsertOnTop, SwirlIconInventory, SwirlIconInventoryOff, SwirlIconIphone, SwirlIconKey, SwirlIconKeyboard, SwirlIconKeyboardHide, SwirlIconLightMode, SwirlIconLike, SwirlIconLink, SwirlIconLive, SwirlIconLoad, SwirlIconLocationOn, SwirlIconLock, SwirlIconLockOpen, SwirlIconLockPerson, SwirlIconLogin, SwirlIconLogout, SwirlIconLongText, SwirlIconMail, SwirlIconManageAccounts, SwirlIconMarkChatRead, SwirlIconMarkChatUnread, SwirlIconMention, SwirlIconMenu, SwirlIconMenuBook, SwirlIconMenuBookFilled, SwirlIconMenuFilled, SwirlIconMessage, SwirlIconMic, SwirlIconMicOff, SwirlIconMoreHorizontal, SwirlIconMoreVertikal, SwirlIconNews, SwirlIconNewsFilled, SwirlIconNewsOff, SwirlIconNextPlan, SwirlIconNotifications, SwirlIconNotificationsActive, SwirlIconNotificationsOff, SwirlIconOpenInFull, SwirlIconOpenInNew, SwirlIconPause, SwirlIconPauseCircle, SwirlIconPeopleAlt, SwirlIconPerson, SwirlIconPersonOff, SwirlIconPhone, SwirlIconPhotoCamera, SwirlIconPictureAsPdf, SwirlIconPictureInPicture, SwirlIconPin, SwirlIconPinOff, SwirlIconPlace, SwirlIconPlayArrow, SwirlIconPoll, SwirlIconPostApproval, SwirlIconPresent, SwirlIconPreview, SwirlIconPrint, SwirlIconPublic, SwirlIconPublicOff, SwirlIconPublishedWithChanges, SwirlIconRatioFourToThree, SwirlIconRatioFreeform, SwirlIconRatioSixteenToNine, SwirlIconRatioSquare, SwirlIconRatioThreeToFour, SwirlIconRatioThreeToTwo, SwirlIconRecieved, SwirlIconRemove, SwirlIconRemoveCircle, SwirlIconRemoveModerator, SwirlIconReply, SwirlIconReport, SwirlIconRoadmap, SwirlIconRotateLeft, SwirlIconRotateRight, SwirlIconScreenshare, SwirlIconScreenshareOff, SwirlIconSearch, SwirlIconSearchStrong, SwirlIconSecure, SwirlIconSend, SwirlIconSettings, SwirlIconShortText, SwirlIconSimplify, SwirlIconSpellcheck, SwirlIconStars, SwirlIconStickyNote, SwirlIconStop, SwirlIconStopCircle, SwirlIconSunny, SwirlIconSync, SwirlIconTasks, SwirlIconTasksFilled, SwirlIconTerminal, SwirlIconTime, SwirlIconTimeFilled, SwirlIconToday, SwirlIconTodayFilled, SwirlIconTranslate, SwirlIconTreeStructure, SwirlIconUndo, SwirlIconUnlockPerson, SwirlIconUpload, SwirlIconUserAdd, SwirlIconUserAssign, SwirlIconVideoCamera, SwirlIconVideoCameraOff, SwirlIconVideoLibrary, SwirlIconVideoPlayer, SwirlIconViewAgenda, SwirlIconVisibility, SwirlIconVisibilityOff, SwirlIconVoice, SwirlIconVolumeUp, SwirlIconWarning, SwirlIconWebAsset, SwirlIconWebAssetOff, SwirlIconWork, SwirlImageGrid, SwirlImageGridItem, SwirlInlineError, SwirlInlineNotification, SwirlInlineStatus, SwirlLightbox, SwirlLink, SwirlList, SwirlMenu, SwirlMenuItem, SwirlModal, SwirlOptionList, SwirlOptionListItem, SwirlOptionListSection, SwirlPagination, SwirlPdfReader, SwirlPopover, SwirlPopoverTrigger, SwirlProgressIndicator, SwirlRadio, SwirlRadioGroup, SwirlResourceList, SwirlResourceListFileItem, SwirlResourceListItem, SwirlResourceListSection, SwirlSearch, SwirlSelect, SwirlSeparator, SwirlShellLayout, SwirlShellNavigationItem, SwirlSkeletonBox, SwirlSkeletonText, SwirlSpinner, SwirlStack, SwirlStatusIndicator, SwirlSwitch, SwirlSymbol, SwirlSymbolAccountCircle, SwirlSymbolAlternateEmail, SwirlSymbolAndroid, SwirlSymbolAnnouncement, SwirlSymbolBackup, SwirlSymbolBeachAccess, SwirlSymbolBookmark, SwirlSymbolCloud, SwirlSymbolCoronavirus, SwirlSymbolDesktopWindows, SwirlSymbolDirectionsCarFilled, SwirlSymbolEditCalendar, SwirlSymbolEmail, SwirlSymbolEmojiFoodBeverage, SwirlSymbolEventMenu, SwirlSymbolFacebook, SwirlSymbolFavorite, SwirlSymbolFitnessCenter, SwirlSymbolFlag, SwirlSymbolFolder, SwirlSymbolGlobe, SwirlSymbolGroups, SwirlSymbolHelp, SwirlSymbolImage, SwirlSymbolInfoMenu, SwirlSymbolInstagram, SwirlSymbolIos, SwirlSymbolLanguage, SwirlSymbolLeaderboard, SwirlSymbolLightbulb, SwirlSymbolLinkedin, SwirlSymbolLocationOn, SwirlSymbolLoyalty, SwirlSymbolMapsHomeWork, SwirlSymbolNotifications, SwirlSymbolOpenInNew, SwirlSymbolPedalBike, SwirlSymbolPinterest, SwirlSymbolPolicy, SwirlSymbolPushPin, SwirlSymbolRedeem, SwirlSymbolReportProblem, SwirlSymbolRestaurant, SwirlSymbolRoadmap, SwirlSymbolRoom, SwirlSymbolSavings, SwirlSymbolSettingsVoice, SwirlSymbolShoppingCart, SwirlSymbolSmartphone, SwirlSymbolStar, SwirlSymbolSupervisorAccount, SwirlSymbolThumbsUpDown, SwirlSymbolTwitter, SwirlSymbolWbSunny, SwirlSymbolWechat, SwirlSymbolWeibo, SwirlSymbolWork, SwirlSymbolXing, SwirlSymbolYoutube, SwirlTab, SwirlTabBar, SwirlTable, SwirlTableCell, SwirlTableColumn, SwirlTableRow, SwirlTableRowGroup, SwirlTabs, SwirlTag, SwirlText, SwirlTextInput, SwirlThemeProvider, SwirlThumbnail, SwirlTimeInput, SwirlToast, SwirlToastProvider, SwirlToggleButton, SwirlToggleGroup, SwirlToolbar, SwirlTooltip, SwirlTreeNavigation, SwirlTreeNavigationItem, SwirlTreeView, SwirlTreeViewItem, SwirlVideoThumbnail, SwirlVisuallyHidden, BooleanValueAccessor,
            SelectValueAccessor,
            TextValueAccessor], exports: [FileManager, SwirlAccordion, SwirlAccordionItem, SwirlActionList, SwirlActionListItem, SwirlActionListSection, SwirlAppBar, SwirlAppIcon, SwirlAppLayout, SwirlAutocomplete, SwirlAvatar, SwirlAvatarGroup, SwirlBadge, SwirlBanner, SwirlBox, SwirlButton, SwirlButtonGroup, SwirlCard, SwirlCarousel, SwirlCarouselSlide, SwirlCheckbox, SwirlChip, SwirlColorInput, SwirlColumns, SwirlConsoleLayout, SwirlDateInput, SwirlDatePicker, SwirlDescriptionList, SwirlDescriptionListItem, SwirlDialog, SwirlEmoji, SwirlEmojiClap, SwirlEmojiHappy, SwirlEmojiIdea, SwirlEmojiLove, SwirlEmojiSad, SwirlEmojiThumbsUp, SwirlEmptyState, SwirlFileChip, SwirlFileUploader, SwirlFileViewer, SwirlFileViewerAudio, SwirlFileViewerCsv, SwirlFileViewerFallback, SwirlFileViewerImage, SwirlFileViewerPdf, SwirlFileViewerText, SwirlFileViewerVideo, SwirlFormControl, SwirlFormGroup, SwirlHeading, SwirlIcon, SwirlIconAdd, SwirlIconAddModerator, SwirlIconAddPhoto, SwirlIconAddReaction, SwirlIconAdminPanelSettings, SwirlIconAi, SwirlIconAiFilled, SwirlIconApps, SwirlIconArrowBack, SwirlIconArrowDownward, SwirlIconArrowForward, SwirlIconArrowLeft, SwirlIconArrowRight, SwirlIconArrowRightSmall, SwirlIconArrowUpward, SwirlIconAspectRatio, SwirlIconAttachment, SwirlIconAudioFile, SwirlIconBarChart, SwirlIconBeachAccess, SwirlIconBeachAccessFilled, SwirlIconBlock, SwirlIconBookmark, SwirlIconBookmarkFilled, SwirlIconCalendarAddOnFilled, SwirlIconCalendarRespond, SwirlIconCalendarToday, SwirlIconCall, SwirlIconCallEnd, SwirlIconCancel, SwirlIconCancelFilled, SwirlIconChatBubble, SwirlIconChats, SwirlIconChatsFilled, SwirlIconCheck, SwirlIconCheckCircle, SwirlIconCheckCircleFilled, SwirlIconCheckSmall, SwirlIconCheckStrong, SwirlIconChevronLeft, SwirlIconChevronRight, SwirlIconClose, SwirlIconCloseFullscreen, SwirlIconCloseSmall, SwirlIconCloudUpload, SwirlIconColumn, SwirlIconComment, SwirlIconContrast, SwirlIconCopy, SwirlIconCrop, SwirlIconDarkMode, SwirlIconDateRange, SwirlIconDelete, SwirlIconDeployedCode, SwirlIconDescription, SwirlIconDesktop, SwirlIconDirectory, SwirlIconDirectoryFilled, SwirlIconDiscover, SwirlIconDockLeft, SwirlIconDockLeftCollapse, SwirlIconDockLeftExpand, SwirlIconDoorOpen, SwirlIconDot, SwirlIconDoubleArrowLeft, SwirlIconDoubleArrowRight, SwirlIconDownload, SwirlIconDragHandle, SwirlIconEdit, SwirlIconEditNote, SwirlIconEmojiMood, SwirlIconEmojiSatisfied, SwirlIconError, SwirlIconExpandLess, SwirlIconExpandMore, SwirlIconExperiment, SwirlIconFile, SwirlIconFileCopy, SwirlIconFilter, SwirlIconFolder, SwirlIconFolderShared, SwirlIconFormatHOne, SwirlIconFormatListBulleted, SwirlIconFullscreen, SwirlIconFullscreenExit, SwirlIconGif, SwirlIconGroupAdd, SwirlIconGroupAssign, SwirlIconGroups, SwirlIconGroupsFilled, SwirlIconHamburgerMenu, SwirlIconHealthAndSafety, SwirlIconHelp, SwirlIconHelpFilled, SwirlIconHighlight, SwirlIconHistory, SwirlIconHome, SwirlIconHrResting, SwirlIconImage, SwirlIconImproveText, SwirlIconInfo, SwirlIconInsertBelow, SwirlIconInsertChart, SwirlIconInsertOnTop, SwirlIconInventory, SwirlIconInventoryOff, SwirlIconIphone, SwirlIconKey, SwirlIconKeyboard, SwirlIconKeyboardHide, SwirlIconLightMode, SwirlIconLike, SwirlIconLink, SwirlIconLive, SwirlIconLoad, SwirlIconLocationOn, SwirlIconLock, SwirlIconLockOpen, SwirlIconLockPerson, SwirlIconLogin, SwirlIconLogout, SwirlIconLongText, SwirlIconMail, SwirlIconManageAccounts, SwirlIconMarkChatRead, SwirlIconMarkChatUnread, SwirlIconMention, SwirlIconMenu, SwirlIconMenuBook, SwirlIconMenuBookFilled, SwirlIconMenuFilled, SwirlIconMessage, SwirlIconMic, SwirlIconMicOff, SwirlIconMoreHorizontal, SwirlIconMoreVertikal, SwirlIconNews, SwirlIconNewsFilled, SwirlIconNewsOff, SwirlIconNextPlan, SwirlIconNotifications, SwirlIconNotificationsActive, SwirlIconNotificationsOff, SwirlIconOpenInFull, SwirlIconOpenInNew, SwirlIconPause, SwirlIconPauseCircle, SwirlIconPeopleAlt, SwirlIconPerson, SwirlIconPersonOff, SwirlIconPhone, SwirlIconPhotoCamera, SwirlIconPictureAsPdf, SwirlIconPictureInPicture, SwirlIconPin, SwirlIconPinOff, SwirlIconPlace, SwirlIconPlayArrow, SwirlIconPoll, SwirlIconPostApproval, SwirlIconPresent, SwirlIconPreview, SwirlIconPrint, SwirlIconPublic, SwirlIconPublicOff, SwirlIconPublishedWithChanges, SwirlIconRatioFourToThree, SwirlIconRatioFreeform, SwirlIconRatioSixteenToNine, SwirlIconRatioSquare, SwirlIconRatioThreeToFour, SwirlIconRatioThreeToTwo, SwirlIconRecieved, SwirlIconRemove, SwirlIconRemoveCircle, SwirlIconRemoveModerator, SwirlIconReply, SwirlIconReport, SwirlIconRoadmap, SwirlIconRotateLeft, SwirlIconRotateRight, SwirlIconScreenshare, SwirlIconScreenshareOff, SwirlIconSearch, SwirlIconSearchStrong, SwirlIconSecure, SwirlIconSend, SwirlIconSettings, SwirlIconShortText, SwirlIconSimplify, SwirlIconSpellcheck, SwirlIconStars, SwirlIconStickyNote, SwirlIconStop, SwirlIconStopCircle, SwirlIconSunny, SwirlIconSync, SwirlIconTasks, SwirlIconTasksFilled, SwirlIconTerminal, SwirlIconTime, SwirlIconTimeFilled, SwirlIconToday, SwirlIconTodayFilled, SwirlIconTranslate, SwirlIconTreeStructure, SwirlIconUndo, SwirlIconUnlockPerson, SwirlIconUpload, SwirlIconUserAdd, SwirlIconUserAssign, SwirlIconVideoCamera, SwirlIconVideoCameraOff, SwirlIconVideoLibrary, SwirlIconVideoPlayer, SwirlIconViewAgenda, SwirlIconVisibility, SwirlIconVisibilityOff, SwirlIconVoice, SwirlIconVolumeUp, SwirlIconWarning, SwirlIconWebAsset, SwirlIconWebAssetOff, SwirlIconWork, SwirlImageGrid, SwirlImageGridItem, SwirlInlineError, SwirlInlineNotification, SwirlInlineStatus, SwirlLightbox, SwirlLink, SwirlList, SwirlMenu, SwirlMenuItem, SwirlModal, SwirlOptionList, SwirlOptionListItem, SwirlOptionListSection, SwirlPagination, SwirlPdfReader, SwirlPopover, SwirlPopoverTrigger, SwirlProgressIndicator, SwirlRadio, SwirlRadioGroup, SwirlResourceList, SwirlResourceListFileItem, SwirlResourceListItem, SwirlResourceListSection, SwirlSearch, SwirlSelect, SwirlSeparator, SwirlShellLayout, SwirlShellNavigationItem, SwirlSkeletonBox, SwirlSkeletonText, SwirlSpinner, SwirlStack, SwirlStatusIndicator, SwirlSwitch, SwirlSymbol, SwirlSymbolAccountCircle, SwirlSymbolAlternateEmail, SwirlSymbolAndroid, SwirlSymbolAnnouncement, SwirlSymbolBackup, SwirlSymbolBeachAccess, SwirlSymbolBookmark, SwirlSymbolCloud, SwirlSymbolCoronavirus, SwirlSymbolDesktopWindows, SwirlSymbolDirectionsCarFilled, SwirlSymbolEditCalendar, SwirlSymbolEmail, SwirlSymbolEmojiFoodBeverage, SwirlSymbolEventMenu, SwirlSymbolFacebook, SwirlSymbolFavorite, SwirlSymbolFitnessCenter, SwirlSymbolFlag, SwirlSymbolFolder, SwirlSymbolGlobe, SwirlSymbolGroups, SwirlSymbolHelp, SwirlSymbolImage, SwirlSymbolInfoMenu, SwirlSymbolInstagram, SwirlSymbolIos, SwirlSymbolLanguage, SwirlSymbolLeaderboard, SwirlSymbolLightbulb, SwirlSymbolLinkedin, SwirlSymbolLocationOn, SwirlSymbolLoyalty, SwirlSymbolMapsHomeWork, SwirlSymbolNotifications, SwirlSymbolOpenInNew, SwirlSymbolPedalBike, SwirlSymbolPinterest, SwirlSymbolPolicy, SwirlSymbolPushPin, SwirlSymbolRedeem, SwirlSymbolReportProblem, SwirlSymbolRestaurant, SwirlSymbolRoadmap, SwirlSymbolRoom, SwirlSymbolSavings, SwirlSymbolSettingsVoice, SwirlSymbolShoppingCart, SwirlSymbolSmartphone, SwirlSymbolStar, SwirlSymbolSupervisorAccount, SwirlSymbolThumbsUpDown, SwirlSymbolTwitter, SwirlSymbolWbSunny, SwirlSymbolWechat, SwirlSymbolWeibo, SwirlSymbolWork, SwirlSymbolXing, SwirlSymbolYoutube, SwirlTab, SwirlTabBar, SwirlTable, SwirlTableCell, SwirlTableColumn, SwirlTableRow, SwirlTableRowGroup, SwirlTabs, SwirlTag, SwirlText, SwirlTextInput, SwirlThemeProvider, SwirlThumbnail, SwirlTimeInput, SwirlToast, SwirlToastProvider, SwirlToggleButton, SwirlToggleGroup, SwirlToolbar, SwirlTooltip, SwirlTreeNavigation, SwirlTreeNavigationItem, SwirlTreeView, SwirlTreeViewItem, SwirlVideoThumbnail, SwirlVisuallyHidden, BooleanValueAccessor,
            SelectValueAccessor,
            TextValueAccessor] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlComponentsModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SwirlComponentsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        ...DIRECTIVES,
                        BooleanValueAccessor,
                        SelectValueAccessor,
                        TextValueAccessor,
                    ],
                    imports: [],
                    exports: [
                        ...DIRECTIVES,
                        BooleanValueAccessor,
                        SelectValueAccessor,
                        TextValueAccessor,
                    ],
                }]
        }] });

/*
 * Public API Surface of component-library
 */

/**
 * Generated bundle index. Do not edit.
 */

export { BooleanValueAccessor, FileManager, SelectValueAccessor, SwirlAccordion, SwirlAccordionItem, SwirlActionList, SwirlActionListItem, SwirlActionListSection, SwirlAppBar, SwirlAppIcon, SwirlAppLayout, SwirlAutocomplete, SwirlAvatar, SwirlAvatarGroup, SwirlBadge, SwirlBanner, SwirlBox, SwirlButton, SwirlButtonGroup, SwirlCard, SwirlCarousel, SwirlCarouselSlide, SwirlCheckbox, SwirlChip, SwirlColorInput, SwirlColumns, SwirlComponentsModule, SwirlConsoleLayout, SwirlDateInput, SwirlDatePicker, SwirlDescriptionList, SwirlDescriptionListItem, SwirlDialog, SwirlEmoji, SwirlEmojiClap, SwirlEmojiHappy, SwirlEmojiIdea, SwirlEmojiLove, SwirlEmojiSad, SwirlEmojiThumbsUp, SwirlEmptyState, SwirlFileChip, SwirlFileUploader, SwirlFileViewer, SwirlFileViewerAudio, SwirlFileViewerCsv, SwirlFileViewerFallback, SwirlFileViewerImage, SwirlFileViewerPdf, SwirlFileViewerText, SwirlFileViewerVideo, SwirlFormControl, SwirlFormGroup, SwirlHeading, SwirlIcon, SwirlIconAdd, SwirlIconAddModerator, SwirlIconAddPhoto, SwirlIconAddReaction, SwirlIconAdminPanelSettings, SwirlIconAi, SwirlIconAiFilled, SwirlIconApps, SwirlIconArrowBack, SwirlIconArrowDownward, SwirlIconArrowForward, SwirlIconArrowLeft, SwirlIconArrowRight, SwirlIconArrowRightSmall, SwirlIconArrowUpward, SwirlIconAspectRatio, SwirlIconAttachment, SwirlIconAudioFile, SwirlIconBarChart, SwirlIconBeachAccess, SwirlIconBeachAccessFilled, SwirlIconBlock, SwirlIconBookmark, SwirlIconBookmarkFilled, SwirlIconCalendarAddOnFilled, SwirlIconCalendarRespond, SwirlIconCalendarToday, SwirlIconCall, SwirlIconCallEnd, SwirlIconCancel, SwirlIconCancelFilled, SwirlIconChatBubble, SwirlIconChats, SwirlIconChatsFilled, SwirlIconCheck, SwirlIconCheckCircle, SwirlIconCheckCircleFilled, SwirlIconCheckSmall, SwirlIconCheckStrong, SwirlIconChevronLeft, SwirlIconChevronRight, SwirlIconClose, SwirlIconCloseFullscreen, SwirlIconCloseSmall, SwirlIconCloudUpload, SwirlIconColumn, SwirlIconComment, SwirlIconContrast, SwirlIconCopy, SwirlIconCrop, SwirlIconDarkMode, SwirlIconDateRange, SwirlIconDelete, SwirlIconDeployedCode, SwirlIconDescription, SwirlIconDesktop, SwirlIconDirectory, SwirlIconDirectoryFilled, SwirlIconDiscover, SwirlIconDockLeft, SwirlIconDockLeftCollapse, SwirlIconDockLeftExpand, SwirlIconDoorOpen, SwirlIconDot, SwirlIconDoubleArrowLeft, SwirlIconDoubleArrowRight, SwirlIconDownload, SwirlIconDragHandle, SwirlIconEdit, SwirlIconEditNote, SwirlIconEmojiMood, SwirlIconEmojiSatisfied, SwirlIconError, SwirlIconExpandLess, SwirlIconExpandMore, SwirlIconExperiment, SwirlIconFile, SwirlIconFileCopy, SwirlIconFilter, SwirlIconFolder, SwirlIconFolderShared, SwirlIconFormatHOne, SwirlIconFormatListBulleted, SwirlIconFullscreen, SwirlIconFullscreenExit, SwirlIconGif, SwirlIconGroupAdd, SwirlIconGroupAssign, SwirlIconGroups, SwirlIconGroupsFilled, SwirlIconHamburgerMenu, SwirlIconHealthAndSafety, SwirlIconHelp, SwirlIconHelpFilled, SwirlIconHighlight, SwirlIconHistory, SwirlIconHome, SwirlIconHrResting, SwirlIconImage, SwirlIconImproveText, SwirlIconInfo, SwirlIconInsertBelow, SwirlIconInsertChart, SwirlIconInsertOnTop, SwirlIconInventory, SwirlIconInventoryOff, SwirlIconIphone, SwirlIconKey, SwirlIconKeyboard, SwirlIconKeyboardHide, SwirlIconLightMode, SwirlIconLike, SwirlIconLink, SwirlIconLive, SwirlIconLoad, SwirlIconLocationOn, SwirlIconLock, SwirlIconLockOpen, SwirlIconLockPerson, SwirlIconLogin, SwirlIconLogout, SwirlIconLongText, SwirlIconMail, SwirlIconManageAccounts, SwirlIconMarkChatRead, SwirlIconMarkChatUnread, SwirlIconMention, SwirlIconMenu, SwirlIconMenuBook, SwirlIconMenuBookFilled, SwirlIconMenuFilled, SwirlIconMessage, SwirlIconMic, SwirlIconMicOff, SwirlIconMoreHorizontal, SwirlIconMoreVertikal, SwirlIconNews, SwirlIconNewsFilled, SwirlIconNewsOff, SwirlIconNextPlan, SwirlIconNotifications, SwirlIconNotificationsActive, SwirlIconNotificationsOff, SwirlIconOpenInFull, SwirlIconOpenInNew, SwirlIconPause, SwirlIconPauseCircle, SwirlIconPeopleAlt, SwirlIconPerson, SwirlIconPersonOff, SwirlIconPhone, SwirlIconPhotoCamera, SwirlIconPictureAsPdf, SwirlIconPictureInPicture, SwirlIconPin, SwirlIconPinOff, SwirlIconPlace, SwirlIconPlayArrow, SwirlIconPoll, SwirlIconPostApproval, SwirlIconPresent, SwirlIconPreview, SwirlIconPrint, SwirlIconPublic, SwirlIconPublicOff, SwirlIconPublishedWithChanges, SwirlIconRatioFourToThree, SwirlIconRatioFreeform, SwirlIconRatioSixteenToNine, SwirlIconRatioSquare, SwirlIconRatioThreeToFour, SwirlIconRatioThreeToTwo, SwirlIconRecieved, SwirlIconRemove, SwirlIconRemoveCircle, SwirlIconRemoveModerator, SwirlIconReply, SwirlIconReport, SwirlIconRoadmap, SwirlIconRotateLeft, SwirlIconRotateRight, SwirlIconScreenshare, SwirlIconScreenshareOff, SwirlIconSearch, SwirlIconSearchStrong, SwirlIconSecure, SwirlIconSend, SwirlIconSettings, SwirlIconShortText, SwirlIconSimplify, SwirlIconSpellcheck, SwirlIconStars, SwirlIconStickyNote, SwirlIconStop, SwirlIconStopCircle, SwirlIconSunny, SwirlIconSync, SwirlIconTasks, SwirlIconTasksFilled, SwirlIconTerminal, SwirlIconTime, SwirlIconTimeFilled, SwirlIconToday, SwirlIconTodayFilled, SwirlIconTranslate, SwirlIconTreeStructure, SwirlIconUndo, SwirlIconUnlockPerson, SwirlIconUpload, SwirlIconUserAdd, SwirlIconUserAssign, SwirlIconVideoCamera, SwirlIconVideoCameraOff, SwirlIconVideoLibrary, SwirlIconVideoPlayer, SwirlIconViewAgenda, SwirlIconVisibility, SwirlIconVisibilityOff, SwirlIconVoice, SwirlIconVolumeUp, SwirlIconWarning, SwirlIconWebAsset, SwirlIconWebAssetOff, SwirlIconWork, SwirlImageGrid, SwirlImageGridItem, SwirlInlineError, SwirlInlineNotification, SwirlInlineStatus, SwirlLightbox, SwirlLink, SwirlList, SwirlMenu, SwirlMenuItem, SwirlModal, SwirlOptionList, SwirlOptionListItem, SwirlOptionListSection, SwirlPagination, SwirlPdfReader, SwirlPopover, SwirlPopoverTrigger, SwirlProgressIndicator, SwirlRadio, SwirlRadioGroup, SwirlResourceList, SwirlResourceListFileItem, SwirlResourceListItem, SwirlResourceListSection, SwirlSearch, SwirlSelect, SwirlSeparator, SwirlShellLayout, SwirlShellNavigationItem, SwirlSkeletonBox, SwirlSkeletonText, SwirlSpinner, SwirlStack, SwirlStatusIndicator, SwirlSwitch, SwirlSymbol, SwirlSymbolAccountCircle, SwirlSymbolAlternateEmail, SwirlSymbolAndroid, SwirlSymbolAnnouncement, SwirlSymbolBackup, SwirlSymbolBeachAccess, SwirlSymbolBookmark, SwirlSymbolCloud, SwirlSymbolCoronavirus, SwirlSymbolDesktopWindows, SwirlSymbolDirectionsCarFilled, SwirlSymbolEditCalendar, SwirlSymbolEmail, SwirlSymbolEmojiFoodBeverage, SwirlSymbolEventMenu, SwirlSymbolFacebook, SwirlSymbolFavorite, SwirlSymbolFitnessCenter, SwirlSymbolFlag, SwirlSymbolFolder, SwirlSymbolGlobe, SwirlSymbolGroups, SwirlSymbolHelp, SwirlSymbolImage, SwirlSymbolInfoMenu, SwirlSymbolInstagram, SwirlSymbolIos, SwirlSymbolLanguage, SwirlSymbolLeaderboard, SwirlSymbolLightbulb, SwirlSymbolLinkedin, SwirlSymbolLocationOn, SwirlSymbolLoyalty, SwirlSymbolMapsHomeWork, SwirlSymbolNotifications, SwirlSymbolOpenInNew, SwirlSymbolPedalBike, SwirlSymbolPinterest, SwirlSymbolPolicy, SwirlSymbolPushPin, SwirlSymbolRedeem, SwirlSymbolReportProblem, SwirlSymbolRestaurant, SwirlSymbolRoadmap, SwirlSymbolRoom, SwirlSymbolSavings, SwirlSymbolSettingsVoice, SwirlSymbolShoppingCart, SwirlSymbolSmartphone, SwirlSymbolStar, SwirlSymbolSupervisorAccount, SwirlSymbolThumbsUpDown, SwirlSymbolTwitter, SwirlSymbolWbSunny, SwirlSymbolWechat, SwirlSymbolWeibo, SwirlSymbolWork, SwirlSymbolXing, SwirlSymbolYoutube, SwirlTab, SwirlTabBar, SwirlTable, SwirlTableCell, SwirlTableColumn, SwirlTableRow, SwirlTableRowGroup, SwirlTabs, SwirlTag, SwirlText, SwirlTextInput, SwirlThemeProvider, SwirlThumbnail, SwirlTimeInput, SwirlToast, SwirlToastProvider, SwirlToggleButton, SwirlToggleGroup, SwirlToolbar, SwirlTooltip, SwirlTreeNavigation, SwirlTreeNavigationItem, SwirlTreeView, SwirlTreeViewItem, SwirlVideoThumbnail, SwirlVisuallyHidden, TextValueAccessor };
//# sourceMappingURL=getflip-swirl-components-angular.mjs.map
